unit IOPORTUNIT;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, Grids, ExtCtrls;

type
  TIOPortbox = class(TForm)
    MainMenu1: TMainMenu;
    Schliessen: TMenuItem;
    Hilfe1: TMenuItem;
    Hilfetext: TMenuItem;
    Info1: TMenuItem;
    Conections: TMenuItem;
    Ansicht1: TMenuItem;
    Verknpfungstabelle1: TMenuItem;
    Portinhalte1: TMenuItem;
    RadioGroup1: TRadioGroup;
    verknbutton: TRadioButton;
    Portliste1: TRadioButton;
    Pinlabel: TLabel;
    schalterlabel: TLabel;
    portlabel: TLabel;
    ioportGrid: TStringGrid;
    Portliste: TListBox;
    labelbox: TGroupBox;
    Label1: TLabel;
    Label3: TLabel;
    Richtung: TLabel;
    procedure Info1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonClick(Sender: TObject);
    procedure MenuClick(Sender: TObject);
    procedure SchliessenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ioportGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure aktualisierenClick(Sender: TObject);
    procedure HilfetextClick(Sender: TObject);
    procedure Portliste1Click(Sender: TObject);
    procedure verknbuttonClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  IOPortbox: TIOPortbox;

implementation

uses pfsimunit, infobox, schalterunit;
{$R *.DFM}


procedure TIOPortbox.Info1Click(Sender: TObject);
begin
  aboutbox.show;
end;

procedure fillioconectgrid (iport : integer);
var ischalter,
    ipin,
    value : integer;
    inhaltstr : string;
    iconnected,
    ok : boolean;
begin
  ioportbox.portlabel.caption := 'Port '+ inttostr (iport) + ' : ';
  for ischalter := 1 to schalteranzahl do
    for ipin := 1 to portbreite do
    begin
      getconnectarray(ischalter, iport, ipin, iconnected, value, ok);
      if ok = false then
      begin
        showmessage ('Ungltige Connectarrayabfrage');
      end
      else
      begin
        if iconnected = true then
        begin
          inhaltstr := '1';
        end
        else
        begin
          inhaltstr := '0';
        end;
        ioportbox.ioportgrid.cells[ischalter, ipin] := inhaltstr;
      end;{end pinindex}
    end; {if}
end;

procedure TIOPortbox.menuClick(Sender: TObject);
var
  eintrag : tmenuitem;

begin
  if Sender is Tmenuitem then
  begin
     eintrag := Sender as Tmenuitem;
{     showmessage ('hurra' + eintrag.caption);}
    fillioconectgrid (eintrag.tag);
{    putinhaltstr (eintrag.tag);}
  end;
end;


procedure TIOPortbox.FormCreate(Sender: TObject);
var index : integer;
    menueintrag : tmenuitem;
begin
  for index := 1 to portanzahl do
  begin
    ioport [index].parent := self;
    ioport [index].height := 47;
    ioport [index]. top := ((index-1 ) div 16 )* 50 + 50;
    ioport [index]. width := 30;
    ioport [index].left :=  ((index - 1) mod 16)*35 + 10;
    ioport [index].layout:= blglyphtop;
    ioport[index].helpcontext := 3250;
    ioport [index].visible :=  true;
    ioport [index].OnClick := ButtonClick;
    ioport [index]. caption := inttostr (index);
    ioport [index].glyph.loadfromfile ('port.bmp');
    menueintrag := tmenuitem.create (self);
    menueintrag.caption := 'Port' + inttostr (index);
    menueintrag.tag := index;
    conections.add (menueintrag);
    menueintrag. onclick := menuclick;
  end;
  if portanzahl > 16 then
  begin
    ioportbox.width := 580;
  end
  else
  begin
    ioportbox.width := Portanzahl  * 35 + 50;
  end;
  ioportgrid.colcount := schalteranzahl + 1 ;
  ioportgrid.rowcount := portbreite + 1 ;
  ioportgrid.height := (portbreite + 1)*15 + 30;
  ioportgrid.top := (((portanzahl-1) div 16)+ 2) *50 + 30 ;
  ioportbox.height := ioportgrid.top + ioportgrid.height + 50;
  if (ioportgrid.colcount * 20) >  (ioportbox.width - 80) then
  begin
    ioportgrid.width := ioportbox.width - 70;
  end
  else
  begin
    ioportgrid.width := (ioportgrid.colcount + 1) * 20;
  end;
  portlabel.top := ioportgrid.top -20;
  pinlabel.top := ioportgrid.top + (portbreite div 2) * 15;
  schalterlabel.top := portlabel.top;
  for index := 1 to schalteranzahl do
    ioportgrid.cells [index, 0] := inttostr (index);
  for index := 1 to portbreite do
  begin
    ioportgrid.cells [0, index] := inttostr (index);
  end;
  portliste.top := 80;
  portliste.width := 220;
  portliste.height := 260;
  portliste.left := 10;
  portliste.visible:= false;
  labelbox.top := 50;
  labelbox.visible:= false;
end;

procedure TIOPortbox.ButtonClick(Sender: TObject);
var
  inhaltstr : string[portbreite];
  Button: TIOPort;
  portindex : integer;
begin
   inhaltstr :='';
   if Sender is TIOPort then
   begin
     Button := Sender as TIOPort;
     for portindex := 1 to portanzahl do
     begin
       if ioport[portindex] = Button then
       begin
         fillioconectgrid (portindex);
       end;
     end;
   end;
end;

procedure TIOPortbox.SchliessenClick(Sender: TObject);
begin
 { main.ioportbtn.glyph.loadfromfile ('iobtn.bmp');
  main.ioportsein1.enabled := true;
  main.ioportsaus1.enabled := false;}
  ioportbox.close;
end;

function fillportliste (portindex: integer) : boolean;
var ok : boolean;
    portstr,
    portinhalt : string;
begin
  ok := false;
  if (portindex < 10 ) then
  begin
    portstr := '  ';
  end
  else
  begin
    portstr := ' ';
  end;
  ok:= true;
  if (ioport[portindex].richtung <> ausgang) and
     (ioport[portindex].richtung <> eingang)  then
  begin
    portinhalt := 'Offen  ';
  end
  else
  begin
    if (ioport[portindex].richtung = ausgang) then
    begin
      portinhalt := 'Ausgang';
    end
    else
    begin
      portinhalt := 'Eingang';
    end;
  end;
  portstr := portstr + inttostr (portindex) + '.   ' + portinhalt;
  portstr := portstr + ': '+ ioport[portindex].inhalt;
  ioportbox.portliste.itemindex := portindex-1  ;
  ioportbox.portliste.items.add (portstr);
  fillportliste := ok;
end;


procedure TIOPortbox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  main.ioportbtn.glyph.loadfromfile ('iobtn.bmp');
  main.ioportsein1.enabled := true;
  main.ioportsaus1.enabled := false;
  ioportbtnzustand := false;
end;

procedure TIOPortbox.ioportGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
var inhaltstr,
    labelstr : string;
    ioportconected,
    ok : boolean ;
    value,
    portindex,
    fehler : integer;
begin
  ok := false;
  labelstr := copy (ioportbox.portlabel.caption, 6, (length(ioportbox.portlabel.caption) -7));
  val (labelstr, portindex, fehler);
  getconnectarray (col, portindex, row, ioportconected, value, ok);
  if ioportconected = true then
  begin
    inhaltstr := '1';
  end
  else
  begin
    inhaltstr := '0';
  end;
  begin
    if inhaltstr = '1' then
    begin
      putconnectarray (col, portindex, row, false, value);
      inhaltstr := '0'
    end
    else
    begin
      if inhaltstr = '0' then
      begin
        putconnectarray (col,portindex, row, true, value);
        inhaltstr := '1'
      end;
    end;
   { inhaltstr := inhaltstr + inttostr (value);}
    ioportgrid.cells[col, row] := inhaltstr;
    ioportbox.aktualisierenclick (sender);
    fillschaltergrid (col);
  end;
end;

procedure TIOPortbox.aktualisierenClick(Sender: TObject);
var portindex,
    schalterindex,
    pinindex,
    zustand : integer;
    conected,
    ok : boolean;
    inhaltstr,
    dummystr,
    zustandstr : string;
begin
  portliste.clear;
  for portindex := 1 to portanzahl do
  begin
    if (ioport[portindex].richtung <> ausgang) and
       (ioport[portindex].richtung <> eingang)  then
    begin
      inhaltstr := '';
      for pinindex:= 1 to portbreite do
      begin
        zustandstr:= '';
        for schalterindex := 1 to schalteranzahl do
        begin
          getconnectarray (schalterindex, portindex, pinindex, conected, zustand, ok);
          if (conected) and (zustand = 1) then
          begin
            zustandstr := '1';
          end;
        end;{ende schalterindex}
        if zustandstr = '' then
        begin
          zustandstr:= '0';
        end;
        inhaltstr := inhaltstr + zustandstr;

      end;  {ende pinindex
      showmessage ('port ist offen : ' + inhaltstr);}
      dummystr:= '00000000000000000000000000000000';
      inhaltstr := copy (dummystr, 1, (32- portbreite )) + inhaltstr;
{      ioport[portindex].inhalt := inhaltstr;}
      ioport[portindex].inhalt := copy (inhaltstr, 25,8);

    end;
    fillportliste (portindex);
  end;
end;

procedure TIOPortbox.HilfetextClick(Sender: TObject);
begin
  application.helpfile :=diplomhilfedatei;
  application.helpjump ('');
end;


procedure TIOPortbox.verknbuttonClick(Sender: TObject);
var index : integer;
begin
  verknbutton.checked := true;
  conections.enabled := true;
  if portanzahl > 16 then
  begin
    ioportbox.width := 580;
  end
  else
  begin
    ioportbox.width := Portanzahl  * 35 + 50;
  end;
  portliste.visible := false;
  labelbox.visible:= false;
  ioportgrid.visible := true;
  pinlabel.visible := true;
  portlabel.visible := true;
  schalterlabel.visible := true;
  for index := 1 to Portanzahl do
  begin
    ioport[index].visible := true;
  end;
end;


procedure TIOPortbox.Portliste1Click(Sender: TObject);
var index : integer;
begin
  conections.enabled := false;
  portliste1.checked := true;
  ioportgrid.visible := false;
  pinlabel.visible := false;
  portlabel.visible := false;
  schalterlabel.visible := false;
  ioportbox.width := 250;
  labelbox.visible:= true;
  for index := 1 to Portanzahl do
  begin
    ioport[index].visible := false;
    fillportliste (index);
  end;
  portliste.visible := true;
  aktualisierenclick (sender);
end;


end.
