unit Befehle;

interface

uses
  Windows, Messages, Classes, Graphics, Controls,
  Dialogs, StdCtrls, Forms, SysUtils;

type
  Tkomandos = class(Tobject)


  private
    { Private-Deklarationen }

  public
    { Public-Deklarationen }
  end;
var
  komandos: Tkomandos;
  function ausfuehren (index : integer) : boolean;
  function kommentieren (index : integer) : boolean;

implementation
{$R *.DFM}
uses pfsimunit, ioportunit,  schalterunit, speicherbox;


 {befehl LDI}
{ldt einen Integer-Wert in ein Prozessorregister
 1.   Register ermitteln
 2.   berprfen ob Variable oder Hexwert
 3.   Variable bzw. Hexwert in Register schreiben }
function ldi (proreg: string; immwert: string) : boolean;
var ok: boolean;
    index,
    wert,
    fehler : longint;
begin
  ok := false;

                    if (copy (immwert, 1, 1)) = 'X' then
                       begin
                        immwert:= copy (immwert,2,8) ;
                        hextodec (immwert, wert, ok);
                                               end
                             else
                             begin
                             val (immwert, wert, fehler);
                             if fehler = 0 then
                             begin
                              immwert := inttohex (wert, 8);
                              ok :=true;
                               end
                              else
                             ok := false
                             end;


  if ok = false then
  begin
    showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
  end;
  putregisterinhex (proreg, index, immwert, ok);

  ldi := ok;
end;        { Ende LDI }
{------------------------------------------------------------------------------}

 {befehl LDR}
{ldt den Inhalt einesr Speicherzelle mit Adresse aus Prozessorregister in ein anders Prozessorregister
 1.   Zielregister ermitteln
 2.   Quellregister ermitteln
 3.   Inhalt der Speicheradresse die in Quellregister beschrieben ist ermitteln
      in Zielregister schreiben }
function ldr (prorega: string; proregb: string) : boolean;
var ok : boolean;
    inhaltbstr,
    inhaltastr,
    inhaltspeicher: string;
    indexa,
    indexb : longint;
begin
  ok := false;
  indexa:= 1;
  indexb:= 1;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
  if ok = false then
  begin
    showmessage ('Ungltiges Register');
  exit;
  end;
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok = false then
    begin
      showmessage ('Adreregisterangabe inkorrekt');
      exit;
    end;
     getspeicherinhalt ( inhaltbstr, inhaltspeicher, ok);
      if OK = false then
      begin
        showmessage ('Speicherinhalt konnte nicht ermittelt werden');
        exit;
      end;

        ok:= putregister (indexa, inhaltspeicher );
    LDR := ok;
end;    { Ende LDR }
{------------------------------------------------------------------------------}
 {befehl LD}
{ldt den Inhalt einer Speicherzelle in ein Prozessorregister
 1.   berprfen ob Speicheradresse gltig
 2.   Register ermitteln
 3.   Speicherinhalt lesen
 4.   Speicherinhalt in Register schreiben }
function ld (proreg: string; addresstr: string) : boolean;
var ok : boolean;
    inhaltstr : string;
    index,
    adresse,
    fehler : longint;
begin
  ok := false;
  getregisterinhalt ( proreg, index, inhaltstr, ok);
  if ok= false then
  begin
    showmessage ('Ungltiges Register ');
  exit;
  end;

     if (copy (addresstr, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (addresstr,2,8), adresse, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (addresstr, adresse, fehler);
                    end;

    if fehler <> 0 then
    begin
      showmessage ('Unzulssige Speicheradresse');
      exit;
    end ;

         addresstr := inttohex (adresse, 8);
      getspeicherinhalt (addresstr, inhaltstr, ok);


    if ok = false then
    begin
      showmessage ('Speicherinhalt konnte nicht ermittelt werden ! ');
      exit;
      end;

      ok:= putregister (index, inhaltstr );


  ld:= ok;
end;    { Ende LD }
{------------------------------------------------------------------------------}

   {befehl LDB}
{ldt den Inhalt eines Bytes aus dem Speicher in ein Prozessorregister
 1.   berprfen ob Speicheradresse gltig
 2.   Register ermitteln
 3.   Speicherinhalt lesen
 4.   Speicherinhalt in Register schreiben }
function ldb (proreg: string; addresstr: string) : boolean;
var ok : boolean;
    inhaltstr : string;
    index,
    adresse,
    fehler : longint;
begin
    ok := false;
  if main.membyteadrs = false then
     begin
     showmessage ('Befehl unzulssig- keine Byteadressierung');
     exit;
     end;

    getregisterinhalt ( proreg, index, inhaltstr, ok);
  if ok= false then
  begin
    showmessage ('Ungltiges Register ');
     exit;
     end;

     if (copy (addresstr, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (addresstr,2,8), adresse, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (addresstr, adresse, fehler);
                    end;

    if fehler <> 0 then
    begin
      showmessage ('Unzulssige Speicheradresse');
      exit;
      end ;

         addresstr := inttohex (adresse, 8);
      getspeicherbyte (addresstr, inhaltstr, ok);


    if ok = false then
    begin
      showmessage ('Speicherinhalt konnte nicht ermittelt werden ! ');
      exit;
      end;

      ok:= putregister (index, inhaltstr );


  ldb:= ok;
end;    { Ende LDB}
{------------------------------------------------------------------------------}


     {befehl LDH}
{ldt den Inhalt eines Halbwortes aus dem Speicher in ein Prozessorregister
 1.   berprfen ob Speicheradresse gltig
 2.   Register ermitteln
 3.   Speicherinhalt lesen
 4.   Speicherinhalt in Register schreiben }
function ldh (proreg: string; addresstr: string) : boolean;
var ok : boolean;
    inhaltstr : string;
    index,
    adresse,
    fehler : longint;
begin
    ok := false;
  if main.membyteadrs = false then
     begin
     showmessage ('Befehl unzulssig- keine Byteadressierung');
     exit;
     end;

    getregisterinhalt ( proreg, index, inhaltstr, ok);
  if ok= false then
  begin
    showmessage ('Ungltiges Register ');
     exit;
     end;

     if (copy (addresstr, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (addresstr,2,8), adresse, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (addresstr, adresse, fehler);
                    end;

    if fehler <> 0 then
    begin
      showmessage ('Unzulssige Speicheradresse');
      exit;
      end ;

         addresstr := inttohex (adresse, 8);
      getspeicherhw (addresstr, inhaltstr, ok);


    if ok = false then
    begin
      showmessage ('Speicherinhalt konnte nicht ermittelt werden ! ');
      exit;
      end;

      ok:= putregister (index, inhaltstr );


  ldh:= ok;
end;    { Ende LDH}
{------------------------------------------------------------------------------}













{ befehl MOV }
{ldt den Inhalt eines Prozessorregisters in ein anderes Prozessorregister
 1.   Zielregister ermitteln
 2.   Quellregistera ermitteln
 3.   Qullregister in Zielregister schreiben }
function MOV (prorega: string; proregb: string) : boolean;
var ok : boolean;
    indexa,
    indexb : longint;
    inhaltastr,
    inhaltbstr : string;
begin
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
  if  ok = false then
  begin
    showmessage ('Ungltiges Zielregister');
  end
  else
  begin
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok= false then
    begin
      showmessage ('Ungltiges Quellregister');
    end
    else
    begin
      ok := putregister (indexa, inhaltbstr);
    end;
  end;
  mov := ok;
end;    { Ende MOV }

{------------------------------------------------------------------------------}
{Befehl ST}
{Speichern eines 32-bit Registerinhaltes auf angegebener Adresse
 1.        Speicheradresse ermitteln
 2.        Register ermitteln
 3.        Daten in Speicher schieben }

function ST (proreg: string; addresstr: string) : boolean;
var ok : boolean;
    inhaltstr : string;
    index,
    fehler,
    adresse: longint;
begin
  ok := false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if ok = false then
  begin
  showmessage ('Ungltiges Register');
  exit;
  end;

    if (copy (addresstr, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (addresstr,2,8), adresse, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (addresstr, adresse, fehler);
                    end;

    if fehler <> 0 then
    begin
      showmessage ('Unzulssige Speicheradresse');
      exit;
    end ;

   addresstr := inttohex (adresse, 8);
   putspeicherinhalt (addresstr, inhaltstr, ok);

  if ok = false   then
  begin
  showmessage ('Fehler bei Schreiben in Speicher');
  exit;
  end;

   ST:= ok;
end;  { Ende ST }

{------------------------------------------------------------------------------}
{Befehl STR}
{Speichern des Inhaltes der Adresse von Quellregister,
 in der Adresse von Zielregister
 1.        Quellregister ermitteln
 2.        Prfen ob Adresse in Quellregister zulssig
 3.        Zielregister ermitteln
 4.        Prfen ob Adresse in Zielregister zulssig
 5.        Daten in Speicher schieben }

function STRBEF (prorega: string; proregb: string) : boolean;
var ok : boolean;
    inhaltastr,
    addresstrb : string;
    indexa,
    indexb : longint;
begin
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
  if  ok = false then
  begin
    showmessage ('Ungltiges Datenregister');
    exit;
  end;
     getregisterinhalt (proregb, indexb, addresstrb, ok);
    if ok= false then
    begin
      showmessage ('Ungltiges Adreregister');
      exit;
    end;
                     {neu}
        putspeicherinhalt ( addresstrb, inhaltastr, ok);
        if  ok = false then
  begin
    showmessage ('Fehler bei Schreiben in Speicher');
    exit;
  end;



  STRBEF:= ok;
 end;  { Ende STR }

{------------------------------------------------------------------------------}
 {befehl LDSR}
{ldt den Inhalt eines Sonderregisters in ein Prozessorregister
 1.   berprfen ob Sonderregister gltig
 2.   Registerinhalt lesen
 3.   Sonderregisterinhalt in Register schreiben }
function LDSR (proreg: string; sonderreg: string) : boolean;
var ok : boolean;
    inhaltstr : string;
    index : longint;
begin
  ok := false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if ok then
  begin
    getsonderreg (sonderreg, index, ok);
  end;
  ldsr := ok;
end;    { Ende LDSR }

{------------------------------------------------------------------------------}
 {befehl STSR}
{speichert den Inhalt eines Prozessorregister in ein Sonderregister
 1.   berprfen ob Sonderregister gltig
 2.   Registerinhalt lesen
 3.   Register in Sonderregisterinhalt schreiben }
function STSR ( proreg: string; sonderreg: string) : boolean;
var ok : boolean;
    inhaltstr : string;
    index : longint;
begin
  ok := false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if ok then
  begin
    putsonderreg (index, sonderreg, ok);
  end;
  stsr := ok;
end;    { Ende STSR }


{------------------------------------------------------------------------------}
   {befehl Zweierkomplement
 Bildet das ZeirKomplement des iHm bergebenen Strings}
 function  zweierkomplement (hexstr: string) : string ;
 Var wert,
     index,
     eins,
     uebertrag,
     ueblast,
     bcdueb,
     ergebnis : longint;
     bkompstr,
     inhaltstr,
     einsstr,
     ergebnisstr : string;
 begin
    bkompstr:=    '00000000000000000000000000000000';
    ergebnisstr:= '00000000000000000000000000000000';
    einsstr :=    '00000000000000000000000000000001';
    uebertrag := 0;
    bcdueb:=0;
    inhaltstr:= hextobin (hexstr);
    for index := 32 downto 1 do
    begin
      wert := strtoint (inhaltstr[index]);
      if wert = 1 then
      begin
        bkompstr[index]:= '0';
      end
      else
      begin
        bkompstr[index]:= '1';
      end;
    end;
    for index := 32 downto 1 do
    begin
      wert := strtoint (bkompstr[index]);
      eins := strtoint (einsstr [index]);
      ergebnis := wert + eins + uebertrag ;

        if index = 28 then
             begin
             bcdueb := uebertrag ;
                  end;


         if index = 1 then
         begin
         ueblast := uebertrag;
         end;
      case ergebnis of
        0  :        begin
                      ergebnisstr[index]:= '0';
                      uebertrag := 0;
                    end;
        1  :        begin
                      ergebnisstr[index]:= '1';
                      uebertrag := 0;
                    end;
        2  :        begin
                      ergebnisstr[index]:= '0';
                      uebertrag := 1;
                    end;
        3  :        begin
                      ergebnisstr[index]:= '1';
                      uebertrag := 1;
                       end;
            end;  {case}
    end;
  {  showmessage ('ergebnisstr : ' + ergebnisstr +
   ', Lnge: ' + inttostr (length(ergebnisstr)));}
    inhaltstr := bintohex (ergebnisstr);
    zweierkomplement := inhaltstr;
            {Flags setzen}
    setzeroflag (inhaltstr);
    setsignedflag (inhaltstr);
    setcarryflag (uebertrag);
    setoverflowflag ((uebertrag xor ueblast));
  {  showmessage ('zweierkomplement: ' + hexstr);}

 end;

 {--------------------------------------------------------}

       {Befehl INC}
{erhht den Inhalt eines Prozessorregister um einen dezimalen Direktwert
 1.   Register ermitteln
 2.   Hexwert aus Dezimal-Direktwert ermitteln
 3.   Register um Hexwert erhhen}

function inc (prorega: string; immwert: string) : boolean;
var ok: boolean;
    inhaltastr,
    inhaltbstr,
    ergebnisstr : string;
    wert,
    indexa,
    indexb,
    index,
    werta,
    wertb,
    ergebnis,
    ueblast,
    fehler,
    bcdueb,
    uebertrag : longint;
    begin
  uebertrag:= 0;
  bcdueb:=0;
  ergebnisstr:= '00000000000000000000000000000000';
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);

    if ok then
  begin
     if (copy (immwert, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (immwert,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (immwert, wert, fehler);
                    end;

    if fehler <> 0 then
    begin
      showmessage ('Unzulssiger Incrementwert!');
    end
    else
    begin
           inhaltbstr := inttohex (wert, 8);
                  inhaltastr:= hextobin (inhaltastr);
      inhaltbstr := hextobin (inhaltbstr);

      for index := 32 downto 1 do
      begin
        werta := strtoint (inhaltastr[index]);
        wertb := strtoint (inhaltbstr[index]);
        ergebnis := werta + wertb + uebertrag;

            if index = 28 then
             begin
             bcdueb := uebertrag ;
                  end;

         if index = 1 then
        begin
        ueblast := uebertrag;
        end;
        case ergebnis of
          0  :        begin
                      ergebnisstr[index]:= '0';
                      uebertrag := 0;
                      end;
          1:          begin
                      ergebnisstr[index]:= '1';
                      uebertrag := 0;
                      end;
          2  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 1;
                     end;
         3:          begin
                       ergebnisstr[index]:= '1';
                       uebertrag := 1;
                      end;

          end;
             end;
      inhaltastr := bintohex (ergebnisstr);
    {  showmessage ('ergebnisstr: ' + inhaltastr);}
      ok := putregister (indexa, inhaltastr);
              {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
      ok:= setcarryflag (uebertrag);
      ok:= setoverflowflag ((uebertrag xor ueblast));
      ok:= setbcdflag (bcdueb);
    end;
    if ok = false then
    begin
      showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
    end;
  end;
  inc := ok;
end;        { Ende INC }



    {------------------------------------------------------------------------------}


  {Befehl DEC}
{verringert den wert in einem Prozessorregister um Dezimalwert
 1.   Register ermitteln
 2.   Hexwert aus Dezimal-Direktwert ermitteln
 3.   Register um Hexwert verringern}

function dec (prorega: string; immwert: string) : boolean;
var ok: boolean;
    inhaltastr,
    inhaltbstr,
    ergebnisstr : string;
    indexa,
    indexb,
    index,
    wert,
    werta,
    wertb,
    ergebnis,
    ueblast,
    fehler,
    bcdueb,
    uebertrag : longint;
begin
  ergebnisstr:= '00000000000000000000000000000000';
  uebertrag := 0;
  bcdueb:=0;
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
  if ok then
      begin
          if (copy (immwert, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (immwert,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (immwert, wert, fehler);
                    end;


    if fehler <> 0 then
    begin
      showmessage ('Unzulssiger Decrementwert!');
    end
    else
    begin
           inhaltbstr := inttohex (wert, 8);
          inhaltastr:= hextobin (inhaltastr);
              inhaltbstr := zweierkomplement(inhaltbstr);
      inhaltbstr := hextobin (inhaltbstr);
         for index := 32 downto 1 do
      begin
        werta := strtoint (inhaltastr[index]);
        wertb := strtoint (inhaltbstr[index]);
        ergebnis := werta + wertb + uebertrag;

              if index = 28 then
             begin
             bcdueb := uebertrag ;
                  end;


          if index = 1then
          begin
          ueblast := uebertrag;
          end;
        case ergebnis of
          0  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag :=0;
                      end;
          1  :        begin
                        ergebnisstr[index]:= '1';
                         uebertrag := 0;
                      end;
          2  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 1;
                      end;
          3  :        begin
                        ergebnisstr[index]:= '1';
                        uebertrag := 1;
                      end;

        end; {case}
      end;
      inhaltastr := bintohex (ergebnisstr);
      if uebertrag = 1 then
      begin
        hextodec (inhaltastr, ergebnis, ok);
        putregister (indexa, inhaltastr);
      end
      else
      begin

        hextodec (inhaltastr, ergebnis, ok);

        inhaltastr:= inttohex (ergebnis, 8);
        ok := putregister (indexa, inhaltastr);
      end;
      ok:= true;
        {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
      ok:= setcarryflag (uebertrag);
      ok:= setoverflowflag ((uebertrag xor ueblast));
      ok:= setbcdflag (bcdueb);
    end;
    if ok = false then
    begin
      showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
    end;
       end;
  dec := ok;
end;        { Ende DEC}


{------------------------------------------------------------------------------}
 {befehl ADD}
{Bitweises addieren zweier Prozessorregisterinhalte ohne bertrag
 1.   Zielegister ermitteln
 2.   Datenregister ermitteln
 3.   Ausgabe in Zielregister}
function ADD (prorega: string; proregb: string) : boolean;
var ok: boolean;
    inhaltastr,
    inhaltbstr,
    ergebnisstr : string;
    indexa,
    indexb,
    index,
    werta,
    wertb,
    ergebnis,
    ueblast,
    bcdueb,
    uebertrag : longint;
    begin
  uebertrag:= 0;
  bcdueb:=0;
  ergebnisstr:= '00000000000000000000000000000000';
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
  if ok then
  begin
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok then
    begin
      inhaltastr:= hextobin (inhaltastr);
      inhaltbstr:= hextobin (inhaltbstr);
      for index := 32 downto 1 do
      begin
        werta := strtoint (inhaltastr[index]);
        wertb := strtoint (inhaltbstr[index]);
        ergebnis := werta + wertb + uebertrag;

         if index = 28 then
             begin
             bcdueb := uebertrag ;
                  end;

         if index = 1 then
        begin
        ueblast := uebertrag;
        end;
        case ergebnis of
          0  :        begin
                      ergebnisstr[index]:= '0';
                      uebertrag := 0;
                      end;
          1:          begin
                      ergebnisstr[index]:= '1';
                      uebertrag := 0;
                      end;
          2  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 1;
                     end;
         3:          begin
                       ergebnisstr[index]:= '1';
                       uebertrag := 1;
                      end;

          end;
             end;
      inhaltastr := bintohex (ergebnisstr);
    {  showmessage ('ergebnisstr: ' + inhaltastr);}
      ok := putregister (indexa, inhaltastr);
              {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
      ok:= setcarryflag (uebertrag);
      ok:= setoverflowflag ((uebertrag xor ueblast));
      ok:= setbcdflag (bcdueb);
    end;
    if ok = false then
    begin
      showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
    end;
  end;
  ADD := ok;
end;        { Ende ADD }
{------------------------------------------------------------------------------}
 {befehl ADDC}
{Bitweises addieren zweier Prozessorregisterinhalte mit bertrag
 1.   Zielegister ermitteln
 2.   Datenregister ermitteln
 3.   Ausgabe in Zielregister}
function ADDC (prorega: string; proregb: string) : boolean;
var ok: boolean;
    inhaltastr,
    inhaltbstr,
    ergebnisstr : string;
    indexa,
    indexb,
    index,
    werta,
    wertb,
    ergebnis,
    ueblast,
    bcdueb,
    uebertrag : longint;
begin
  ergebnisstr:= '00000000000000000000000000000000';
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
   bcdueb:=0;
  if ok then
  begin
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok then
    begin
      if (copy (getstatusstring (true),2,1) = '1') then
         begin
         uebertrag := 1;
         end
         else
         begin
         uebertrag := 0;
         end;
      inhaltastr:= hextobin (inhaltastr);
      inhaltbstr:= hextobin (inhaltbstr);
      for index := 32 downto 1 do
      begin
        werta := strtoint (inhaltastr[index]);
        wertb := strtoint (inhaltbstr[index]);
        ergebnis := werta + wertb + uebertrag ;

            if index = 28 then
             begin
             bcdueb := uebertrag ;
                  end;

        if index = 1 then
        begin
        ueblast := uebertrag;
        end;

        case ergebnis of
          0  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 0;
                      end;
          1  :        begin
                        ergebnisstr[index]:= '1';
                        uebertrag := 0;
                      end;
          2  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 1;
                      end;
          3  :        begin
                        ergebnisstr[index]:= '1';
                        uebertrag := 1;
                      end;
               end;
      end;
      inhaltastr := bintohex (ergebnisstr);
      hextodec (inhaltastr, ergebnis, ok);
      ok := putregister (indexa, inhaltastr);
         {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
      ok:= setcarryflag (uebertrag);
      ok:= setoverflowflag ((uebertrag xor ueblast));
      ok:= setbcdflag (bcdueb);
    end;
    if ok = false then
    begin
      showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
    end;
  end;
  ADDC := ok;
end;        { Ende ADDC }
{------------------------------------------------------------------------------}

{------------------------------------------------------------------------------}
 {befehl CPL}
{Zweierkomplement erzeugen
 1.   Zielegister ermitteln
 2.   Datenregister ermitteln
 3.   Ausgabe in Zielregister}
function CPL (proreg: string) : boolean;
var ok: boolean;
    inhaltstr : string;
    indexreg : longint;
begin
  ok := false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok then
  begin
    inhaltstr := zweierkomplement (inhaltstr)  ;
    ok := putregister(indexreg, inhaltstr);
  end;
  if ok = false then
  begin
    showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
  end;
  CPL := ok;
end;        { Ende CPL }
{------------------------------------------------------------------------------}
 {befehl INV}
{Inhalt eines Prozessorregisters invertieren
 1.   Ausgabe in Register}
function INV (proreg: string) : boolean;
var ok: boolean;
    inhaltstr,
    ergebnisstr: string;
    index,
    indexreg,
    wert : longint;
begin
  ergebnisstr:= '00000000000000000000000000000000';
  ok := false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok  then
  begin
    inhaltstr:= hextobin (inhaltstr);
    for index := 32 downto 1 do
    begin
      wert := strtoint (inhaltstr[index]);
      if wert = 1 then
      begin
        ergebnisstr[index]:= '0';
      end
      else
      begin
        ergebnisstr[index]:= '1';
      end;
      ok := true;
    end;
    index:= 1;
    inhaltstr := bintohex (ergebnisstr);
    ok := putregister (indexreg, inhaltstr);
        {Flags setzen}
    ok:= setzeroflag (inhaltstr);
    ok:= setsignedflag (inhaltstr);
    if ok = false then
    begin
      showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
    end;
  end;
  INV := ok;
end;        { Ende INV }
{------------------------------------------------------------------------------}
 {befehl SUBC}
{Bitweises subtrahieren zweier Prozessorregisterinhalte mit bertrag
 1.   Zielegister ermitteln
 2.   Datenregister ermitteln
 3.   Ausgabe in Zielregister}
function SUBC (prorega: string; proregb: string) : boolean;
var ok: boolean;
    inhaltastr,
    inhaltbstr,
    ergebnisstr : string;
    indexa,
    index,
    werta,
    wertb,
    ergebnis,
    ueblast,
    bcdueb,
    uebertrag : longint;
begin
  ergebnisstr:= '00000000000000000000000000000000';
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
  bcdueb:=0;
  if ok then
  begin
    getregisterinhalt (proregb, index, inhaltbstr, ok);
    if ok then
    begin
      if (copy (getstatusstring (true),2,1) = '1') then
         begin
         uebertrag := 1;
         end
         else
         begin
         uebertrag := 0;
         end;
      inhaltastr:= hextobin (inhaltastr);
      inhaltbstr:=  (inhaltbstr);
      inhaltbstr := zweierkomplement (inhaltbstr);
      inhaltbstr:=  hextobin (inhaltbstr);

      for index := 32 downto 1 do
      begin
        werta := strtoint (inhaltastr[index]);
        wertb := strtoint (inhaltbstr[index]);
        ergebnis := werta + wertb + uebertrag ;

           if index = 28 then
             begin
             bcdueb := uebertrag ;
                  end;

        if index = 1 then
        begin
        ueblast := uebertrag;
        end;
        case ergebnis of
          0  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 0;
                      end;
          1  :        begin
                        ergebnisstr[index]:= '1';
                        uebertrag := 0;
                      end;
          2  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 1;
                      end;
          3  :        begin
                        ergebnisstr[index]:= '1';
                        uebertrag := 1;
                      end;

        end; {case}
      end;
      inhaltastr := bintohex (ergebnisstr);
      if uebertrag = 1 then
      begin
        hextodec (inhaltastr, ergebnis, ok);
        ok := putregister (indexa, inhaltastr);
      end
      else
      begin

        hextodec (inhaltastr, ergebnis, ok);

        inhaltastr:= inttohex (ergebnis, 8);
        ok := putregister (indexa, inhaltastr);
      end;
        {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
      ok:= setcarryflag (uebertrag);
      ok:= setoverflowflag ((uebertrag xor ueblast));
      ok:= setbcdflag (bcdueb);
    end;
    if ok = false then
    begin
      showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
    end;
  end;
  SUBC := ok;
end;        { Ende SUBC }
{------------------------------------------------------------------------------}
 {befehl SUB}
{Bitweises subtrahieren zweier Prozessorregisterinhalte mit bertrag
 1.   Zielegister ermitteln
 2.   Datenregister ermitteln
 3.   Ausgabe in Zielregister}
function SUB (prorega: string; proregb: string) : boolean;
var ok: boolean;
    inhaltastr,
    inhaltbstr,
    ergebnisstr : string;
    indexa,
    indexb,
    index,
    werta,
    wertb,
    ergebnis,
    ueblast,
    bcdueb,
    uebertrag : longint;
begin
  ergebnisstr:= '00000000000000000000000000000000';
  uebertrag := 0;
  bcdueb:=0;
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
  if ok then
  begin
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok then
    begin
      inhaltastr:= hextobin (inhaltastr);
      inhaltbstr := zweierkomplement (inhaltbstr);
      inhaltbstr:=  hextobin (inhaltbstr);

      for index := 32 downto 1 do
      begin
        werta := strtoint (inhaltastr[index]);
        wertb := strtoint (inhaltbstr[index]);
        ergebnis := werta + wertb + uebertrag;

                if index = 28 then
             begin
             bcdueb := uebertrag ;
                  end;

          if index = 1 then
          begin
          ueblast := uebertrag;
          end;
        case ergebnis of
          0  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag :=0;
                      end;
          1  :        begin
                        ergebnisstr[index]:= '1';
                         uebertrag := 0;
                      end;
          2  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 1;
                      end;
          3  :        begin
                        ergebnisstr[index]:= '1';
                        uebertrag := 1;
                      end;

        end; {case}
      end;
      inhaltastr := bintohex (ergebnisstr);
      if uebertrag = 1 then
      begin
        hextodec (inhaltastr, ergebnis, ok);
        putregister (indexa, inhaltastr);
      end
      else
      begin

        hextodec (inhaltastr, ergebnis, ok);

        inhaltastr:= inttohex (ergebnis, 8);
        ok := putregister (indexa, inhaltastr);
      end;
      ok:= true;
        {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
      ok:= setcarryflag (uebertrag);
      ok:= setoverflowflag ((uebertrag xor ueblast));
      ok:= setbcdflag (bcdueb);
    end;
    if ok = false then
    begin
      showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
    end;
  end;
  SUB := ok;
end;        { Ende SUB }
{------------------------------------------------------------------------------}
{befehl andlog}
{Bitweise "Und"-Verknpfung zweier Registerinhalte
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises Verknpfen der Inhalte
 4.       Schreiben in Zielregister       }
function andlog  (prorega: string; proregb: string ): boolean;
var ok : boolean;
    index,
    indexareg,
    indexbreg : longint;
    inhaltastr,
     inhaltbstr,
     ergebnisstr : string;
begin
  ergebnisstr := '00000000000000000000000000000000';
  ok:= false;
  getregisterinhalt (prorega, indexareg, inhaltastr, ok);
  if ok then
  begin
    getregisterinhalt (proregb, indexbreg, inhaltbstr, ok);
    if ok then
    begin
      inhaltastr := hextobin (inhaltastr);
      inhaltbstr := hextobin (inhaltbstr);
      for index := 1 to 32 do
      begin
        if ((inhaltastr[index] = '1') and (inhaltbstr[index] = '1')) then
        begin
          ergebnisstr[index] := '1';
        end
        else
        begin
          ergebnisstr[index] := '0';
        end;
      end;
      inhaltastr := bintohex (ergebnisstr);
      ok := putregister (indexareg, inhaltastr);
       {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
    end;
  end;
  andlog := ok;
end;
{Ende von andlog}
{------------------------------------------------------------------------------}
{befehl Orlog}
{Bitweise "Oder"-Verknpfung zweier Registerinhalte
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises Verknpfen der Inhalte
 4.       Schreiben in Zielregister       }
function orlog  (prorega: string; proregb: string ): boolean;
var ok : boolean;
    index,
    indexareg,
    indexbreg : longint;
    inhaltastr,
    inhaltbstr,
    ergebnisstr : string;
begin
  ergebnisstr := '00000000000000000000000000000000';
  ok:= false;
  getregisterinhalt (prorega, indexareg, inhaltastr, ok);
  if ok  then
  begin
    getregisterinhalt (proregb, indexbreg, inhaltbstr, ok);
    if ok then
    begin
      inhaltastr := hextobin (inhaltastr);
      inhaltbstr := hextobin (inhaltbstr);
      for index := 1 to 32 do
      begin
        if ((inhaltastr[index] = '1') or (inhaltbstr[index] = '1')) then
        begin
          ergebnisstr[index] := '1';
        end
        else
        begin
          ergebnisstr[index] := '0';
        end;
      end;
      inhaltastr := bintohex (ergebnisstr);
      ok := putregister (indexareg, inhaltastr);
       {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
    end;
  end;
  orlog := ok;
end;
{Ende von orlog}
{------------------------------------------------------------------------------}

{befehl Xorlog}
{Bitweise "Antivalenz"-Verknpfung zweier Registerinhalte
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises Verknpfen der Inhalte
 4.       Schreiben in Zielregister       }
function xorlog  (prorega: string; proregb: string ): boolean;
var ok : boolean;
    index,
    indexareg,
    indexbreg :longint;
    a, b : integer;
    inhaltastr,
     inhaltbstr,
     ergebnisstr : string;
begin
  ergebnisstr := '00000000000000000000000000000000';
  ok:= false;
  getregisterinhalt (prorega, indexareg, inhaltastr, ok);
  if ok then
  begin
    getregisterinhalt (proregb, indexbreg, inhaltbstr, ok);
    if ok  then
    begin
      inhaltastr := hextobin (inhaltastr);
      inhaltbstr := hextobin (inhaltbstr);
      for index := 1 to 32 do
      begin
        a:= strtoint (inhaltastr[index]);
        b:= strtoint (inhaltbstr[index]);
        if (a xor b) = 1  then
        begin
          ergebnisstr[index] := '1';
        end
        else
        begin
          ergebnisstr[index] := '0';
        end;
      end;
      inhaltastr := bintohex (ergebnisstr);
      ok := putregister (indexareg, inhaltastr);
      {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
    end;
  end;
  xorlog := ok;
end;
{Ende von xorlog}
{------------------------------------------------------------------------------}

{befehl shiftleft}
{Bitweise "Links-schieben" eines Registerinhaltes
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function shiftleft  (proreg: string; anzahl: string ): boolean;
var ok : boolean;
    index,
    indexa,
    indexb,
    wert,
    inhalt,
    carrywert,
    fehler : longint;
    inhaltstr : string;
begin
  carrywert := 0;
  ok:= false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if ok then
  begin

     if (copy (anzahl, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (anzahl,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (anzahl, wert, fehler);
                    end;


    if ((fehler <> 0) or (wert < 0) or (wert > 32))  then
    begin
      showmessage ('Schiebewert unzulssig ');
      ok := false;
    end
    else
    begin
      inhaltstr := hextobin (inhaltstr);
      for indexa := 1 to wert do
      begin
        carrywert := strtoint (inhaltstr[1]);
        for indexb := 1 to 31 do
        begin
          inhaltstr[indexb]:= inhaltstr[indexb+1];
        end;
        inhaltstr[32] := '0';
      end;
      hextodec (inhaltstr, inhalt, ok);
      inhaltstr := bintohex (inhaltstr);
      ok := putregister (index, inhaltstr);
      {Flags setzen}
      ok:= setzeroflag (inhaltstr);
      ok:= setsignedflag (inhaltstr);
      ok:= setcarryflag (carrywert);
    end;
  end;
  shiftleft := ok;
end;
{Ende von shiftleft}
{------------------------------------------------------------------------------}

{befehl shiftright}
{Bitweise "Rechts-schieben" eines Registerinhaltes
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function shiftright  (proreg: string; anzahl: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    index,
    wert,
    carrywert,
    fehler : longint;
    inhaltstr : string;
begin
  carrywert := 0;
  ok:= false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if ok then
  begin
       if (copy (anzahl, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (anzahl,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (anzahl, wert, fehler);
                    end;

    if ((fehler <> 0) or (wert < 0) or (wert > 32))  then
    begin
      showmessage ('Unzulssiger Schiebewert');
      ok := false;
    end
    else
    begin
      inhaltstr := hextobin (inhaltstr);

      for indexa := 1 to wert do
      begin
        carrywert := strtoint (inhaltstr[32]);
        for indexb := 32 downto 2 do
        begin
          inhaltstr[indexb]:= inhaltstr[indexb-1];
        end;
       inhaltstr[1] := '0';
      end;
      inhaltstr := bintohex (inhaltstr);
      ok := putregister (index, inhaltstr);
      {Flags setzen}
      ok:= setzeroflag (inhaltstr);
      ok:= setsignedflag (inhaltstr);
      ok:= setcarryflag (carrywert);
    end;
  end;
  shiftright := ok;
end;
{Ende von shiftright}
{------------------------------------------------------------------------------}

//****

  {befehl shiftright arithmetically}
{Bitweise "Rechts-schieben" eines Registerinhaltes
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function shiftrighta  (proreg: string; anzahl: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    index,
    wert,
    carrywert,
    fehler : longint;
    inhaltstr : string;
begin
  carrywert := 0;
  ok:= false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if ok then
  begin
       if (copy (anzahl, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (anzahl,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (anzahl, wert, fehler);
                    end;

    if ((fehler <> 0) or (wert < 0) or (wert > 32))  then
    begin
      showmessage ('Unzulssiger Schiebewert');
      ok := false;
    end
    else
    begin
      inhaltstr := hextobin (inhaltstr);

      for indexa := 1 to wert do
      begin
        carrywert := strtoint (inhaltstr[32]);
        for indexb := 32 downto 2 do
        begin
          inhaltstr[indexb]:= inhaltstr[indexb-1];
        end;

      end;
      inhaltstr := bintohex (inhaltstr);
      ok := putregister (index, inhaltstr);
      {Flags setzen}
      ok:= setzeroflag (inhaltstr);
      ok:= setsignedflag (inhaltstr);
      ok:= setcarryflag (carrywert);
    end;
  end;
  shiftrighta := ok;
end;
{Ende von shiftright}
{------------------------------------------------------------------------------}

//****
{befehl shrr}
{Bitweise "Rechts-schieben" eines Registerinhaltes'a' um Registerinhalt 'b'
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function shrr  (prorega: string; proregb: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    indexareg,
    wertb,
    carrywert : longint;
    inhaltastr,
    inhaltbstr : string;
begin
  indexareg := 0;
  carrywert:= 0;
  ok:= false;
  getregisterinhalt (prorega, indexareg, inhaltastr, ok);
  if ok  then
  begin
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok then
    begin
      hextodec (inhaltbstr, wertb, ok);
      if ((ok <> true) or (wertb < 0) or (wertb > 32))  then
      begin
        showmessage ('Schiebewert unzulssig ');
        ok := false;
      end
      else
      begin
        inhaltastr := hextobin (inhaltastr);
       { inhaltstr := (inhaltstr shl  wert);}
        for indexa := 1 to wertb do
        begin
          carrywert := strtoint (inhaltastr[32]);
          for indexb := 32 downto 2 do
          begin
            inhaltastr[indexb]:= inhaltastr[indexb-1];
          end;
          inhaltastr[1] := '0';
        end;
        inhaltastr := bintohex (inhaltastr);
        ok:= putregister (indexareg, inhaltastr);
              {Flags setzen}
        ok:= setzeroflag (inhaltastr);
        ok:= setsignedflag (inhaltastr);
        ok:= setcarryflag (carrywert);
      end;
    end;
  end;
  shrr := ok;
end;
{Ende von shiftright um Registerinhalt}
{------------------------------------------------------------------------------}
//****

  //****
{befehl shrr}
{Bitweise "Rechts-schieben" eines Registerinhaltes'a' um Registerinhalt 'b' arithmetisch
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function srar  (prorega: string; proregb: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    indexareg,
    wertb,
    carrywert : longint;
    inhaltastr,
    inhaltbstr : string;
begin
  indexareg := 0;
  carrywert:= 0;
  ok:= false;
  getregisterinhalt (prorega, indexareg, inhaltastr, ok);
  if ok  then
  begin
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok then
    begin
      hextodec (inhaltbstr, wertb, ok);
      if ((ok <> true) or (wertb < 0) or (wertb > 32))  then
      begin
        showmessage ('Schiebewert unzulssig ');
        ok := false;
      end
      else
      begin
        inhaltastr := hextobin (inhaltastr);
       { inhaltstr := (inhaltstr shl  wert);}
        for indexa := 1 to wertb do
        begin
          carrywert := strtoint (inhaltastr[32]);
          for indexb := 32 downto 2 do
          begin
            inhaltastr[indexb]:= inhaltastr[indexb-1];
          end;

        end;
        inhaltastr := bintohex (inhaltastr);
        ok:= putregister (indexareg, inhaltastr);
              {Flags setzen}
        ok:= setzeroflag (inhaltastr);
        ok:= setsignedflag (inhaltastr);
        ok:= setcarryflag (carrywert);
      end;
    end;
  end;
  srar := ok;
end;
{Ende von shiftright um Registerinhalt}


//****

{befehl shlr}
{Bitweise "Links-schieben" eines Registerinhaltes'a' um Registerinhalt 'b'
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function shlr  (prorega: string; proregb: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    indexareg,
    wertb,
    carrywert : longint;
    inhaltastr,
    inhaltbstr : string;
begin
  indexareg:=0;
  carrywert := 0;
  ok:= false;
  getregisterinhalt (prorega, indexareg, inhaltastr, ok);
  if ok  then
  begin
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok  then
    begin
      hextodec (inhaltbstr, wertb, ok);
      if ((ok <> true) or (wertb < 0) or (wertb > 32))  then
      begin
        showmessage ('Unzulssiger Schiebewert ');
        ok := false;
      end
      else
      begin
        inhaltastr := hextobin (inhaltastr);
       { inhaltstr := (inhaltstr shl  wert);}
        for indexa := 1 to wertb do
        begin
          carrywert := strtoint (inhaltastr[1]);
          for indexb := 1 to 31 do
          begin
            inhaltastr[indexb]:= inhaltastr[indexb+1];
          end;
          inhaltastr[32] := '0';
        end;
        inhaltastr := bintohex (inhaltastr);
        ok:= putregister (indexareg, inhaltastr);
                      {Flags setzen}
        ok:= setzeroflag (inhaltastr);
        ok:= setsignedflag (inhaltastr);
        ok:= setcarryflag (carrywert);
      end;
    end;
  end;
  shlr := ok;
end;
{Ende von shiftleft um Registerinhalt}
{------------------------------------------------------------------------------}


{befehl Rotateright}
{Bitweise "Rechts-rotieren" eines Registerinhaltes
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function rotr  (proreg: string; anzahl: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    index,
    wert,
    carrywert,
    fehler : longint;
    inhaltstr : string;
begin
  ok:= false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if ok then
  begin

      if (copy (anzahl, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (anzahl,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (anzahl, wert, fehler);
                    end;

    if ((fehler <> 0) or (wert < 0) or (wert > 32))  then
    begin
      showmessage ('Unzulssiger Schiebewert ');
      ok := false;
    end
    else
    begin
      inhaltstr := hextobin (inhaltstr);
      for indexa := 1 to wert do
      begin
        val (inhaltstr[32], carrywert, fehler) ;
        for indexb := 32 downto 2 do
        begin
          inhaltstr[indexb]:= inhaltstr[indexb-1];
        end;
        if carrywert = 1 then
        begin
          inhaltstr[1] := '1';
        end
        else
        begin
          inhaltstr[1] := '0';
        end;
      end;
      inhaltstr := bintohex (inhaltstr);
      ok:= putregister (index, inhaltstr);
        {Flags setzen}
        ok:= setzeroflag (inhaltstr);
        ok:= setsignedflag (inhaltstr);
        ok:= setcarryflag (carrywert);
    end;
  end;
  rotr := ok;
end;
{Ende von rotateright}
{------------------------------------------------------------------------------}


{befehl Rotatleft}
{Bitweise "Rechts-rotieren" eines Registerinhaltes
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function rotl  (proreg: string; anzahl: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    index,
    wert,
    carrywert,
    fehler : longint;
    inhaltstr : string;
begin
  ok:= false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if ok then
  begin

      if (copy (anzahl, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (anzahl,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (anzahl, wert, fehler);
                    end;

    if ((fehler <> 0) or (wert < 0) or (wert > 32))  then
    begin
      showmessage ('Schiebewert unzulssig ');
      ok := false;
    end
    else
    begin
      inhaltstr := hextobin (inhaltstr);
      for indexa := 1 to wert do
      begin
        val (inhaltstr[1], carrywert, fehler) ;
      for indexb := 1 to 31 do
        begin
          inhaltstr[indexb]:= inhaltstr[indexb+1];
        end;
        if carrywert = 1 then
        begin
          inhaltstr[32] := '1';
        end
        else
        begin
          inhaltstr[32] := '0';
        end;
      end;
      inhaltstr := bintohex (inhaltstr);
      ok:= putregister (index, inhaltstr);
           {Flags setzen}
        ok:= setzeroflag (inhaltstr);
        ok:= setsignedflag (inhaltstr);
        ok:= setcarryflag (carrywert);
    end;
  end;
  rotl := ok;
end;
{Ende von rotateleft}
{------------------------------------------------------------------------------}

{befehl rotateright Register}
{Bitweise "Rechts-rotieren" eines Registerinhaltes "a" um Inhalt von Register "b"
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function rotrr  (prorega: string; proregb: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    indexareg,
    indexbreg,
    wert,
    carrywert,
    fehler : longint;
    inhaltastr,
    inhaltbstr : string;
begin
  ok:= false;
  getregisterinhalt (prorega, indexareg, inhaltastr, ok);
  if ok then
  begin
    getregisterinhalt (proregb, indexbreg, inhaltbstr, ok);
    if ok then
    begin
     hextodec (inhaltbstr, wert, ok);
      if ((ok <> true) or (wert < 0) or (wert > 32))  then
      begin
        showmessage ('Schiebewert unzulssig ');
        ok := false;
      end
      else
      begin
        inhaltastr := hextobin (inhaltastr);
        for indexa := 1 to wert do
        begin
          val (inhaltastr[32], carrywert, fehler) ;
          for indexb := 32 downto 2 do
          begin
            inhaltastr[indexb]:= inhaltastr[indexb-1];
          end;
          if carrywert = 1 then
          begin
            inhaltastr[1] := '1';
          end
          else
          begin
            inhaltastr[1] := '0';
          end;{inttostr(ord (main.carryflagbox.checked)) ;}
        end;
        inhaltastr := bintohex (inhaltastr);
        ok := putregister (indexareg, inhaltastr);
           {Flags setzen}
        ok:= setzeroflag (inhaltastr);
        ok:= setsignedflag (inhaltastr);
        ok:= setcarryflag (carrywert);
      end;
    end;
  end;
  rotrr := ok;
end;
{Ende von rotateright um register}

{------------------------------------------------------------------------------}
{befehl rotateleft Register}
{Bitweise "Links-rotieren" eines Registerinhaltes "a" um Inhalt von Register "b"
 1.       Zielregister ermitteln
 2.       Operandenregister ermitteln
 3.       Bitweises schieben des Inhaltes
 4.       Schreiben in Zielregister       }
function rotLr  (prorega: string; proregb: string ): boolean;
var ok : boolean;
    indexa,
    indexb,
    indexareg,
    indexbreg,
    wert,
    carrywert,
    fehler : longint;
    inhaltastr,
    inhaltbstr : string;
begin
  ok:= false;
  getregisterinhalt (prorega, indexareg, inhaltastr, ok);
  if ok  then
  begin
    getregisterinhalt (proregb, indexbreg, inhaltbstr, ok);
    if ok then
    begin
      hextodec (inhaltbstr, wert, ok);
      if ((ok<> true) or (wert < 0 )or (wert > 32))  then
      begin
        showmessage ('Schiebewert unzulssig');
        ok:= false;
      end
      else
      begin
        inhaltastr := hextobin (inhaltastr);
        for indexa := 1 to wert do
        begin
          val (inhaltastr[1], carrywert, fehler) ;
          for indexb := 1 to 31 do
          begin
            inhaltastr[indexb]:= inhaltastr[indexb+1];
          end;
          if carrywert = 1 then
          begin
            inhaltastr[32] := '1';
          end
          else
          begin
            inhaltastr[32] := '0';
          end;{inttostr(ord (main.carryflagbox.checked)) ;}
        end;
        inhaltastr := bintohex (inhaltastr);
        ok:= putregister (indexareg, inhaltastr);
        ok:= true;
            {Flags setzen}
        ok:= setzeroflag (inhaltastr);
        ok:= setsignedflag (inhaltastr);
        ok:= setcarryflag (carrywert)
        ;end;
    end;
  end;
  rotlr := ok;
end;
{Ende von rotateleft um register}

{------------------------------------------------------------------------------}


  //******
  {befehl Rotate left extended}
{Bitweise "links-rotieren" eines Registerinhaltes
 1.       Zielregister ermitteln
 2.       Schieben
 3.       Schreiben in Zielregister       }

 function rtlx  (proreg: string): boolean;
var ok : boolean;
    indexa,
    indexb,
    index,
    wert,
    carrywert,
    carryw,
    fehler : longint;
    inhaltstr : string;
begin
  ok:= false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if main.carryflagbox.checked = true then carrywert:=1
  else carrywert:=0;
  inhaltstr := hextobin (inhaltstr);
  if ok = false then
  begin rtlx:= ok;
  exit
  end
  else
      begin
       val (inhaltstr[1], carryw, fehler);
          for indexb := 1 to 31 do
           begin
          inhaltstr[indexb]:= inhaltstr[indexb+1];
           end;
           end;
        if carrywert = 1 then
        begin
          inhaltstr[32] := '1';
        end
        else
        begin
          inhaltstr[32] := '0';
             end;
      inhaltstr := bintohex (inhaltstr);
      ok:= putregister (index, inhaltstr);
           {Flags setzen}
        ok:= setzeroflag (inhaltstr);
        ok:= setsignedflag (inhaltstr);
        ok:= setcarryflag (carryw);
   rtlx := ok;
   end;
{Ende von rotateleft extended}

 { //'**********

   {befehl Rotate right extended}
{Bitweise "Rechts-rotieren" eines Registerinhaltes
 1.       Zielregister ermitteln
 2.       Schieben
 3.       Schreiben in Zielregister       }

 function rtrx  (proreg: string): boolean;
var ok : boolean;
    indexa,
    indexb,
    index,
    wert,
    carrywert,
    carryw,
    fehler : longint;
    inhaltstr : string;
begin
  ok:= false;
  getregisterinhalt (proreg, index, inhaltstr, ok);
  if main.carryflagbox.checked = true then carrywert:=1
  else carrywert:=0;
  inhaltstr := hextobin (inhaltstr);
  if ok = false then
  begin rtrx:= ok;
  exit
  end
  else
      begin
       val (inhaltstr[32], carryw, fehler);
          for indexb := 32 downto 2 do
           begin
          inhaltstr[indexb]:= inhaltstr[indexb-1];
           end;
           end;
        if carrywert = 1 then
        begin
          inhaltstr[1] := '1';
        end
        else
        begin
          inhaltstr[1] := '0';
             end;
      inhaltstr := bintohex (inhaltstr);
      ok:= putregister (index, inhaltstr);
           {Flags setzen}
        ok:= setzeroflag (inhaltstr);
        ok:= setsignedflag (inhaltstr);
        ok:= setcarryflag (carryw);
   rtrx := ok;
   end;
{Ende von rotateright extended}

  {befehl CMP}
{Vergleichen zweier Prozessorregisterinhalte
 1.   Zielegister ermitteln
 2.   Datenregister ermitteln
 3.   Ausgabe in flags}
function CMP (prorega: string; proregb: string) : boolean;
var ok: boolean;
    inhaltastr,
    inhaltbstr,
    ergebnisstr : string;
    equal,
    indexa,
    indexb,
    index,
    werta,
    wertb,
    ergebnis,
    ueblast,
    bcdueb,
    uebertrag : longint;
begin
  ergebnisstr:= '00000000000000000000000000000000';
  ok := false;
  getregisterinhalt (prorega, indexa, inhaltastr, ok);
  if ok then
  begin
    getregisterinhalt (proregb, indexb, inhaltbstr, ok);
    if ok then
    begin
      uebertrag := 0;
      inhaltbstr := zweierkomplement (inhaltbstr);
      inhaltastr:=  hextobin (inhaltastr);
      inhaltbstr:=  hextobin (inhaltbstr);

      for index := 32 downto 1 do
      begin
        werta := strtoint (inhaltastr[index]);
        wertb := strtoint (inhaltbstr[index]);
        ergebnis := werta + wertb + uebertrag ;

                 if index = 28 then
             begin
             bcdueb := uebertrag ;
                  end;

         if index = 1 then
         begin
         ueblast := uebertrag;
         end;
        case ergebnis of
          0  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 0;
                      end;
          1  :        begin
                        ergebnisstr[index]:= '1';
                        uebertrag := 0;
                      end;
          2  :        begin
                        ergebnisstr[index]:= '0';
                        uebertrag := 1;
                      end;
          3  :        begin
                        ergebnisstr[index]:= '1';
                        uebertrag := 1;
                      end;

        end; {case}
      end;
      inhaltastr := bintohex (ergebnisstr);
      if uebertrag = 1 then
      begin
        hextodec (inhaltastr, ergebnis, ok);
      end
      else
      begin
        inhaltastr := zweierkomplement (inhaltastr);
        hextodec (inhaltastr, ergebnis, ok);
        ergebnis := -ergebnis ;
        inhaltastr:= inttohex (ergebnis, 8);
      end;
      ok:= true;
      if ergebnis = -ergebnis then
      begin
        equal := 1;
      end
      else
      begin
        equal := 0;
      end;
        {Flags setzen}
      ok:= setzeroflag (inhaltastr);
      ok:= setsignedflag (inhaltastr);
      ok:= setcarryflag (uebertrag);
      ok:= setoverflowflag ((uebertrag xor ueblast));
      ok:= setbcdflag (bcdueb);
    end;
    if ok = false then
    begin
      showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
    end;
  end;
  CMP := ok;
end;        { Ende CMP }
{------------------------------------------------------------------------------}
 {befehl PUSH}
{Inhalt eines Prozessorregisters auf den Stack schieben
 1.   Ausgabe in Register}
function PUSH (proreg: string) : boolean;
var ok: boolean;
    inhaltstr,
    stackstr : string;
    indexreg,
    adresse : longint;
begin
  ok := false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok then
  begin
    stackstr := getstackstring (ok);
    hextodec (stackstr, adresse, ok);
    if ((adresse > endadresse) or (adresse <= 0 )or (ok = false)) then
    begin
      showmessage ('Ungltige Stackadresse')
      end
          else
    begin
      adresse := adresse -1;
      stackstr := speicher[adresse];
      stackstr := copy (speicher[adresse], 1, 11);
      stackstr := stackstr + inhaltstr;
      speicher[adresse] := stackstr;
      stackstr := inttohex (adresse, 8);
      ok := putstackstring (stackstr);
    end;
  end;
  if ok = false then
  begin
    showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
  end ;
  push := ok;
end;        { Ende PUSH }
{------------------------------------------------------------------------------}
 {befehl PUSHSTA}
{Inhalt des Statusregisters auf den Stack schieben}
function PUSHSTA (proreg: string) : boolean;
var ok: boolean;
    inhaltstr,
    stackstr,
    statusstr : string;
    adresse : longint;
begin
  ok := false;
  statusstr := getstatusstring (ok);
  inhaltstr := '00000000000000000000000000'+ statusstr;
  inhaltstr := bintohex (inhaltstr);
  stackstr := getstackstring (ok);
  hextodec (stackstr, adresse, ok);
  if ((adresse > endadresse) or (ok = false) or (adresse <1)) then
  begin
    showmessage ('Ungltige Stackadresse' );
  end
  else
  begin
    adresse := adresse -1;
    stackstr := copy (speicher[adresse], 1, 11);
    stackstr := stackstr + inhaltstr;
    speicher[adresse] := stackstr;
    stackstr := inttohex (adresse, 8);
    ok := putstackstring (stackstr);
    ok:=true;
  end;
  if ok = false then
  begin
    showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
  end ;
  pushsta := ok;
end;        { Ende PUSHSTA }
{------------------------------------------------------------------------------}
 {befehl PUSHALL}
{Inhalt des Statusregisters und aller Prozessorregister auf den Stack schieben}
function PUSHALL (proreg: string) : boolean;
var ok: boolean;
    inhaltstr,
    stackstr,
    statusstr : string;
    index,
    indexreg,
    adresse : longint;
begin
  ok := false;
  statusstr := getstatusstring (ok);
  inhaltstr := statusstr + '00';
  stackstr := getstackstring (ok);
  hextodec (stackstr, adresse, ok);
  if ((adresse > endadresse) or (adresse <= registeranzahl+1) or (ok = false)) then
  begin
    showmessage ('Ungltige Stackadresse' );
  end
  else
  begin
    adresse := adresse -1;
    stackstr := copy (speicher[adresse], 1, 11);
    stackstr := stackstr + inhaltstr;
    speicher[adresse] := stackstr;
    if (adresse < registeranzahl) then
    begin
      showmessage ('Stackoverflow');
      indexg := maxzeile;
    end
    else
    begin
      for index := registeranzahl downto 1 do
      begin
        adresse := adresse -1;
        stackstr := copy (speicher[adresse], 1, 11);
        proreg := 'p' + inttostr (index);
        getregisterinhalt (proreg, indexreg, inhaltstr, ok);
        stackstr := stackstr + inhaltstr;
        speicher[adresse] := stackstr;
      end;
      stackstr := inttohex (adresse, 8);
      ok := putstackstring (stackstr);
      ok:=true;
    end;
  end;
  pushall := ok;
end;        { Ende PUSHALL }
{------------------------------------------------------------------------------}
 {befehl POP}
{Laden eines Registerinhaltes vom Stack
 1.   Ausgabe in Register}
function POP (proreg: string) : boolean;
var ok: boolean;
    inhaltstr,
    inhaltstack,
    stackstr : string;
    indexreg,
    adresse : longint;
begin
  ok := false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok= false  then
  begin
    showmessage ('Unzulssiges Register');
  end
  else
  begin
    stackstr := getstackstring (ok);
    getspeicherinhalt (stackstr, inhaltstack, ok);
    if (ok = false) then
    begin
      showmessage ('Unzulssige Stackadresse');
    end
    else
    begin
      hextodec (stackstr, adresse, ok);
      if adresse >= endadresse then
      begin
        showmessage ('Unzulssige Stackadresse');
      end
      else
      begin
        ok := putregister (indexreg, inhaltstack);
        adresse := adresse + 1;
        stackstr := inttohex (adresse, 8);
        ok := putstackstring (stackstr);
        setzeroflag (inhaltstr);
        setsignedflag (inhaltstr);
      end;
    end;
  end;
  pop := ok;
end;        { Ende POP }

{------------------------------------------------------------------------------}
 {befehl POPSTA}
{Inhalt des Statusregisters vom Stack lesen}
function POPSTA (proreg: string) : boolean;
var ok: boolean;
    inhaltstr,
    stackstr : string;
    adresse : longint;
begin
  ok := false;
  stackstr :=getstackstring (ok);
  hextodec (stackstr, adresse, ok);
  if ((adresse > endadresse) or (ok = false) or (adresse < 0)) then
  begin
    showmessage ('Ungltige Stackadresse' );
  end
  else
  begin
    inhaltstr := copy (speicher[adresse], 14, 6);
    OK:= putstatusstring (inhaltstr);
    adresse:= adresse + 1;
    stackstr := inttohex (adresse, 8);
    ok := putstackstring (stackstr);
    setflag (inhaltstr);
    ok:=true;
  end;
  popsta := ok;
end;        { Ende POPSTA }

{------------------------------------------------------------------------------}
 {befehl POPALL}
{Inhalt des Statusregisters und aller Prozessorregister vom Stack lesen}
function POPALL (proreg: string) : boolean;
var ok: boolean;
    inhaltstr,
    stackstr : string;
    index,
    adresse : longint;
begin
  ok := false;
  stackstr := getstackstring (ok);
  hextodec (stackstr, adresse, ok);
  if ((adresse > (endadresse- registeranzahl)) or (ok = false) or (adresse < 0)) then
  begin
    showmessage ('Ungltige Stackadresse' );
  end
  else
  begin
    for index := 1 to registeranzahl do
    begin
      inhaltstr := copy (speicher[adresse], 12, 8);
      ok := putregister (index, inhaltstr);
      adresse := adresse +1;
    end;
    inhaltstr := copy (speicher[adresse], 12, 6);
    ok := putstatusstring( inhaltstr);
    stackstr := inttohex (adresse, 8);
    ok := putstackstring (stackstr);
    setzeroflag (inhaltstr);
    setsignedflag (inhaltstr);
    ok:=true;
  end;
  popall := ok;
end;        { Ende POPALL }

{------------------------------------------------------------------------------}
 {befehl CALL}
{aufrufen eines Unterprogrammes}
function CALL (markestr: string) : boolean;
var ok: boolean;
    inhaltstr,
    counterstr,
    stackstr : string;
    calladresse,
    indexmarke,
    stackadresse : longint;
begin
  ok := false;
  checkmarke (markestr, indexmarke, ok);
  if ok = false then
  begin
    showmessage ('Ungltige Sprungmarke' );
  end
  else
  begin
    stackstr := getstackstring (ok);
    hextodec (stackstr, stackadresse, ok);
    stackadresse := stackadresse - 1;
    counterstr:= inttohex (indexg,8);
    inhaltstr := copy (speicher[stackadresse],1,11);
    inhaltstr := inhaltstr + counterstr;
    speicher[stackadresse] := inhaltstr;
    indexg:= indexmarke;
    putstackstring (inttohex (stackadresse, 8));
    ok := true;

  end;
  call := ok;
end;              {ende call}

{------------------------------------------------------------------------------}
 {befehl jmp}
{Unbedingte Verzweigung}
function JMP (markestr: string) : boolean;
var ok: boolean;
    indexmarke : longint;
begin
  ok := false;
  checkmarke (markestr, indexmarke, ok);
  if ok = false then
  begin
    showmessage ('Ungltige Sprungmarke' );
  end
  else
  begin
    indexg := indexmarke;
    markestr := inttohex (indexmarke, 8);
    ok := putprogcounterstring (markestr);
    ok := true;
  end;
  jmp := ok;
end;     {ende jmp}

{------------------------------------------------------------------------------}
 {befehl ret
 }
{Laden eines Speicherinhaltes vom Stack in den Programmzhler
 1.   Ausgabe in Register}
function RET (adressestr: string) : boolean;
var ok: boolean;
    inhaltstr,
    counterstr,
    stackstr : string;
    index,
    adresse : longint;
begin
  ok := false;
  stackstr := getstackstring (ok);
  hextodec (stackstr, adresse, ok);
  if ((adresse >= endadresse ) or (ok = false)) then
  begin
    showmessage ('Ungltige Stackadresse' );
  end
  else
  begin
    inhaltstr := copy (speicher[adresse], 12, 8);
    hextodec (inhaltstr, index, ok);
    indexg:= index;
    counterstr := inttohex(index, 8);
    ok := putprogcounterstring( counterstr );
    adresse := adresse + 1;
    stackstr := inttohex (adresse, 8);
    ok := putstackstring (stackstr);
    ok:= true;
  end;
  if ok = false then
  begin
    showmessage ('Befehl konnte nicht ausgefhrt werden ! ');
  end ;
  ret := ok;
end;        { Ende ret }

{------------------------------------------------------------------------------}
 {befehl bra}
{aufrufen eines Unterprogrammes}
function BRA (proreg: string) : boolean;
var ok: boolean;
    inhaltstr,
    adressestr : string;
    indexreg,
    jmpadresse : longint;
begin
  ok := false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok  then
  begin
    hextodec (inhaltstr, jmpadresse, ok);
    if ((jmpadresse > Maxzeile) or (jmpadresse < 0) or (ok = false)) then
    begin
      showmessage ('Ungltige Sprungadresse' );
    end
    else
    begin
      indexg := jmpadresse;
      adressestr := inttohex (jmpadresse, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end;
  bra := ok;
end;   {Ende Bra}
{------------------------------------------------------------------------------}

   {befehl jpbc }
{springen zur marke bei BF=1 }
function jpbc (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.bcdflagbox.checked then
  begin

    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end
  else
  begin

    ok:= true;
  end;
  jpbc := ok;
end;   {Ende jpbc }

   //------------------------------------------------------------------------

  {befehl jpnbc }
{springen zur marke bei BF=0 }
function jpnbc (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.bcdflagbox.checked = false then
  begin
{    showmessage ('Carryflag erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end
  else
  begin

    ok:= true;
  end;
  jpnbc := ok;
end;   {Ende jpnbc }


   //---------------------------------------------------------------------

    {befehl jpd }
{springen zur marke bei   DF=1 }
function jpd (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.dummyflagbox.checked then
  begin

    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end
  else
  begin

    ok:= true;
  end;
  jpd := ok;
end;   {Ende jpd }

//----------------------------------------------------------------------



 {befehl jpnd }
{springen zur marke bei DF=1 }
function jpnd (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.dummyflagbox.checked = false then
  begin

    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end
  else
  begin

    ok:= true;
  end;
  jpnd := ok;
end;   {Ende jpnd }



//*******************************



 {befehl jpz oder jpe}
{springen zur marke bei ZF=1 }
function jpz (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.zeroflagbox.checked then
  begin
{    showmessage ('Zeroflag erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end
  else
  begin
{    showmessage ('Kein zeroflag gesetzt');   }
    ok:= true;
  end;
  jpz := ok;
end;   {Ende jpz bzw. jpe}
{------------------------------------------------------------------------------}
 {befehl jpnz oder jpne}
{springen zur marke bei ZF=0 }
function jpnz (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.zeroflagbox.checked = false then
  begin
{    showmessage ('Zeroflag erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpnz := true;
end;   {Ende jpnz bzw. jpne}
{------------------------------------------------------------------------------}
 {befehl jpc }
{springen zur marke bei CF=1 }
function jpC (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.carryflagbox.checked then
  begin
{    showmessage ('Carryflag erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end
  else
  begin
    {showmessage ('Kein Carryflag gesetzt');}
    ok:= true;
  end;
  jpc := ok;
end;   {Ende jpc }

{------------------------------------------------------------------------------}
 {befehl jpo }
{springen zur marke bei OF=1 }
function jpo (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.overflowbox.checked then
  begin
{    showmessage ('Overflowflag erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end
  else
  begin
    {showmessage ('Kein Carryflag gesetzt');}
    ok:= true;
  end;
  jpo := ok;
end;   {Ende jpo }

{------------------------------------------------------------------------------}
 {befehl jpnc}
{springen zur marke bei CF=0 }
function jpnc (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.carryflagbox.checked = false then
  begin
{    showmessage ('Zeroflag erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpnc := true;
end;   {Ende jpnc}

{------------------------------------------------------------------------------}
 {befehl jpno}
{springen zur marke bei OF=0 }
function jpno (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.overflowbox.checked = false then
  begin
{    showmessage ('Zeroflag erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpno := true;
end;   {Ende jpno}

{------------------------------------------------------------------------------}
 {befehl jpp }
{springen zur marke bei SF=0 }
function jpp (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.signedflagbox.checked then
  begin
{    showmessage ('Signedflag nicht erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
      ok := true;
    end;
  end
  else
  begin
    {showmessage ('Kein Carryflag gesetzt');}
    ok:= true;
  end;
  jpp := ok;
end;   {Ende jpp }

{------------------------------------------------------------------------------}
 {befehl jpn}
{springen zur marke bei SF=1 }
function jpn (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if main.signedflagbox.checked = true then
  begin
{    showmessage ('Signedflag erfllt');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpn := true;
end;   {Ende jpn}

{------------------------------------------------------------------------------}
 {befehl jpb}
{springen zur marke bei ZF=0 und CF =0 belov}
function jpb (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if ((main.Zeroflagbox.checked = false) and (main.Carryflagbox.checked = false))
  then
  begin
{    showmessage ('Jump Below');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpb := true;
end;   {Ende jpb}

{------------------------------------------------------------------------------}
 {befehl jpa}
{springen zur marke bei ZF=0 und CF =1 above }
function jpa (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if ((main.Zeroflagbox.checked = false) and (main.Carryflagbox.checked = true))
  then
  begin
{    showmessage ('Jump above');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpa := true;
end;   {Ende jpa}

{------------------------------------------------------------------------------}
 {befehl jpaE}
{springen zur marke bei ZF=1 oder CF =1 above-equal}
function jpae (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if ((main.Zeroflagbox.checked = true) or (main.Carryflagbox.checked = true))
  then
  begin
{    showmessage ('Jump above-equal');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpae := true;
end;   {Ende jpae}
{------------------------------------------------------------------------------}
 {befehl jpbE}
{springen zur marke bei ZF=1 oder CF =0 belov-equal}
function jpbe (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if ((main.Zeroflagbox.checked = true) or (main.Carryflagbox.checked = false))
  then
  begin
{    showmessage ('Jump above-equal');}
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpbe := true;
end;   {Ende jpbe}
{------------------------------------------------------------------------------}
 {befehl jpl}
{springen zur marke bei SF xor OF = 1 less}
function jpl (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if ((main.Signedflagbox.checked = true) xor (main.overflowbox.checked = true))
  then
  begin
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpl := true;
end;   {Ende jpl}

{------------------------------------------------------------------------------}
 {befehl jpg}
{springen zur marke bei SF xor OF = 0 greater}
function jpg (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if not (((main.Signedflagbox.checked = true) xor (main.overflowbox.checked = true)))
  then
  begin
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpg := true;
end;   {Ende jpg}

{------------------------------------------------------------------------------}
 {befehl jpng}
{springen zur marke bei SF xor OF = 1  oder ZF =1    not greater}
function jpng (markestr: string) : boolean;
var ok: boolean;
    adressestr : string;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if (((main.Signedflagbox.checked = true) xor (main.overflowbox.checked = true))
     or (main.zeroflagbox.checked = true))
  then
  begin
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpng := true;
end;   {Ende jpng}

{------------------------------------------------------------------------------}
 {befehl jpnl}
{springen zur marke bei SF xor OF =0  oder ZF =1    not greater}
function jpnl (markestr: string) : boolean;
var ok: boolean;
    adressestr :string ;
    indexmarke : longint;
begin
  ok := false;
  markestr := trim (markestr);
  if (not ((main.Signedflagbox.checked = true) xor (main.overflowbox.checked = true))
     or (main.zeroflagbox.checked = true))
  then
  begin
    checkmarke (markestr, indexmarke, ok);
    if ok = false then
    begin
      showmessage ('Ungltige Sprungmarke' );
    end
    else
    begin
      indexg := indexmarke;
      adressestr := inttohex (indexmarke, 8);
      ok := putprogcounterstring (adressestr);
    end;
    ok:= true;
  end;
  jpnl := true;
end;   {Ende jpnl}

{------------------------------------------------------------------------------}
{setbit}
function setb (proreg: string; immwert: string): boolean;
var inhaltstr : string;
    ok: boolean;
    indexreg,
    wert,
    fehler : longint;
begin
  ok:= false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok = false then
  begin
    showmessage ('Unzulssigs Register');
  end
  else
  begin
    inhaltstr := hextobin (inhaltstr);

     if (copy (immwert, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (immwert,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (immwert, wert, fehler);
                    end;

    if (fehler <> 0) or (wert < 0) or (wert > 31) then
    begin
      showmessage ('Unzulassiger Bitwert');
    end
    else
    begin
      wert := 32 - wert;
      inhaltstr[wert]:= '1';
      inhaltstr := bintohex (inhaltstr);
      putregister (indexreg, inhaltstr);
      ok:= true;
    end;
  end;
  setb := ok;
end;                      {ende setb
{------------------------------------------------------------------------------}


{clearbit}
function clr (proreg: string; immwert: string): boolean;
var inhaltstr : string;
    ok: boolean;
    indexreg,
    wert,
    fehler : longint;
begin
  ok:= false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok = false then
  begin
    showmessage ('Unzulssiges Register');
  end
  else
  begin
    inhaltstr := hextobin (inhaltstr);

                    if (copy (immwert, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (immwert,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (immwert, wert, fehler);
                    end;

        if (fehler <> 0) or (wert > 31) or (wert < 0) then
    begin
      showmessage ('Unzulassiger Bitwert');
    end
    else
    begin
      wert:= 32 - wert;
      inhaltstr[wert]:= '0';
      inhaltstr := bintohex (inhaltstr);
      putregister (indexreg, inhaltstr);
      ok:= true;
    end;
  end;
  clr := ok;
end;             {ende clr}

{------------------------------------------------------------------------------}
{clearbit register}
function clrr (prorega: string; proregb: string): boolean;
var inhaltastr,
    inhaltbstr : string;
    ok: boolean;
    indexrega,
    indexregb,
    wert,
    fehler : longint;
begin
  ok:= false;
  getregisterinhalt (prorega, indexrega, inhaltastr, ok);
  if ok = false then
  begin
    showmessage ('Unzulssigs Zielregister');
  end
  else
  begin
    getregisterinhalt (proregb, indexregb, inhaltbstr, ok);
    if ok = false then
    begin
      showmessage ('Unzulssigs Operandenregister');
    end
    else
    begin
      hextodec (inhaltbstr, wert, ok);
      if (ok = false) or (wert > 31) or (wert < 0) then
      begin
        showmessage ('Unzulassiger Bitwert');
      end
      else
      begin
        wert := 32- wert ;
        inhaltastr:= hextobin (inhaltastr);
        inhaltastr[wert]:= '0';
        inhaltastr := bintohex (inhaltastr);
        putregister (indexrega, inhaltastr);
        ok:= true;
      end;
    end;
  end;
  clrr := ok;
end;    {Ende clrr}

{------------------------------------------------------------------------------}
{setbit register}
function setr (prorega: string; proregb: string): boolean;
var inhaltastr,
    inhaltbstr : string;
    ok: boolean;
    indexrega,
    indexregb,
    wert,
    fehler : longint;
begin
  ok:= false;
  getregisterinhalt (prorega, indexrega, inhaltastr, ok);
  if ok = false then
  begin
    showmessage ('Unzulssigs Zielregister');
  end
  else
  begin
    getregisterinhalt (proregb, indexregb, inhaltbstr, ok);
    if ok = false then
    begin
      showmessage ('Unzulssigs Operandenregister');
    end
    else
    begin

         hextodec (inhaltbstr, wert, ok);

      if (ok = false) or (wert > 31) or (wert < 0) then
      begin
        showmessage ('Unzulassiger Bitwert');
      end
      else
      begin
        wert := 32 - wert;
        inhaltastr:= hextobin (inhaltastr);
        inhaltastr[wert]:= '1';
        inhaltastr := bintohex (inhaltastr);
        putregister (indexrega, inhaltastr);
        ok:= true;
      end;
    end;
  end;
  setr := ok;
end;    {Ende setr}

{------------------------------------------------------------------------------}
{testbit}
function bit (proreg: string; immwert: string): boolean;
var inhaltstr: string;
    ok: boolean;
    indexreg,
    wert,
    fehler : longint;

 begin
  ok:= false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok = false then
  begin
    showmessage ('Unzulssiges Register');
  end
  else
  begin

  inhaltstr := hextobin (inhaltstr);


    if (copy (immwert, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (immwert,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (immwert, wert, fehler);
                    end;

    if (fehler <> 0) or (wert > 31) or (wert < 0) then
    begin
      showmessage ('Unzulassiger Bitwert');
    end
    else
    begin
      wert := 32-wert;
      if (inhaltstr[wert]= '1') then
      begin
        setzeroflag ('12345678');
             end
      else
      begin
        setzeroflag ('00000000');
             end;
    end;
      ok:= true;
  end;
  bit := ok;
end;                      {ende bit}
{------------------------------------------------------------------------------}
{testbit register}
function bitr (prorega: string; proregb: string): boolean;
var inhaltastr,
    inhaltbstr : string;
    ok,
    hexboolean: boolean;
    indexrega,
    indexregb,
    wert,
    schleife,
    fehler : longint;
begin
  ok:= false;
  hexboolean := false;
  getregisterinhalt (prorega, indexrega, inhaltastr, ok);
  if ok = false then
  begin
    showmessage ('Unzulssigs Prfregister');
  end
  else
  begin
    getregisterinhalt (proregb, indexregb, inhaltbstr, ok);
    if ok = false then
    begin
      showmessage ('Unzulssigs Werteregister');
    end
    else
    begin
      for schleife := 1 to 8 do
      begin
        if ord(inhaltbstr[schleife]) > 63 then
        hexboolean := true;
      end;
      if hexboolean then
      begin
        hextodec (inhaltbstr, wert, ok);
        inhaltbstr := inttostr (wert);
      end;

     hextodec (inhaltbstr, wert, ok);

      if (ok = false) or (wert > 31) or (wert < 0) then
           begin
        showmessage ('Unzulassiger Bitwert');
        ok:= false;
        end
      else
      begin
        wert := 32 - wert;
        inhaltastr := hextobin (inhaltastr);
        if (inhaltastr[wert]= '1') then
        begin
          setzeroflag ('12345678');
        end
        else
        begin
          setzeroflag ('00000000');
        end;
      end;
    end;
  end;
  bitr := ok;
end;                      {ende bitr}
{------------------------------------------------------------------------------}
function xhochy (Basis, exponent : integer) : extended;
var index,
    ergebnis : integer;
begin
  ergebnis := 1;
  for index := 1 to exponent do
    ergebnis := ergebnis * basis;
  xhochy := ergebnis;
end;

//****************


{------------------------------------------------------------------------------}


{copy inverted ZF to bit in reg}
function bzf (proreg: string; immwert: string): boolean;
var inhaltstr : string;
    ok: boolean;
    indexreg,
    wert,
    fehler : longint;
begin
  ok:= false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok = false then
  begin
    showmessage ('Unzulssiges Register');
  end
  else
  begin
    inhaltstr := hextobin (inhaltstr);

                    if (copy (immwert, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (immwert,2,8), wert, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (immwert, wert, fehler);
                    end;

        if (fehler <> 0) or (wert > 31) or (wert < 0) then
    begin
      showmessage ('Unzulassiger Bitwert');
    end
    else
    begin
      wert:= 32 - wert;

        if main.zeroflagbox.checked = false then      inhaltstr[wert]:= '1'
          else       inhaltstr[wert]:= '0';

      inhaltstr := bintohex (inhaltstr);
      putregister (indexreg, inhaltstr);
      ok:= setzeroflag (inhaltstr);
      ok:= true;
    end;
  end;
  bzf := ok;
end;             {ende bzf}

{--------------------------------


{copy inverted ZF to bit in reg according to bitadrs in reg}
function bzfr (prorega: string; proregb: string): boolean;  var inhaltastr,
    inhaltbstr : string;
    ok: boolean;
    indexrega,
    indexregb,
    wert,
    fehler : longint;
begin
  ok:= false;
  getregisterinhalt (prorega, indexrega, inhaltastr, ok);
  if ok = false then
  begin
    showmessage ('Unzulssigs Zielregister');
  end
  else
  begin
    getregisterinhalt (proregb, indexregb, inhaltbstr, ok);
    if ok = false then
    begin
      showmessage ('Unzulssigs Operandenregister');
    end
    else
    begin

         hextodec (inhaltbstr, wert, ok);

      if (ok = false) or (wert > 31) or (wert < 0) then
      begin
       showmessage ('Unzulassiger Bitwert');
      end
      else
      begin
        wert := 32 - wert;
        inhaltastr:= hextobin (inhaltastr);

        if main.zeroflagbox.checked = false then      inhaltastr[wert]:= '1'
          else       inhaltastr[wert]:= '0';

       inhaltastr := bintohex (inhaltastr);
        putregister (indexrega, inhaltastr);
         ok:= setzeroflag (inhaltastr);
        ok:= true;
      end;
    end;
  end;
  bzfr := ok;
end;    {Ende bzfr}

//*****************





{------------------------------------------------------------------------------}
{Ausgabe eines registerinhaltes auf einen Port}
function out (proreg: string; portstr: string): boolean;
var inhaltstr : string;
    ok: boolean;
    indexreg,
    portindex,
    inhaltreg,
    fehler : longint;
begin
  ok:= false;
  getregisterinhalt (proreg, indexreg, inhaltstr, ok);
  if ok <> false then
  begin

     if (copy (portstr, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (portstr,2,8), portindex, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (portstr, portindex, fehler);
                    end;

    if (fehler <>0 ) or (portindex < 1) or (portindex > portanzahl) then
    begin
      showmessage ('Unzulssiger Port');
      ok:= false;
    end
    else
    begin
      ioport[portindex].richtung := ausgang;
      hextodec (inhaltstr, inhaltreg, ok);

      if (fehler<> 0) then
      begin
        showmessage ('Unzulssiger Registerinhalt');
        ok:= false;
      end
      else
      begin
        inhaltstr := inttohex(inhaltreg, 8);
        inhaltstr := hextobin (inhaltstr);
        inhaltstr := copy (inhaltstr, (32- portbreite + 1), portbreite);
        ioport[portindex].inhalt := inhaltstr;
        ioportunit.ioportbox.aktualisierenclick (main);
      end;
    end;
  end;
  out := ok;
end;

{------------------------------------------------------------------------------}
{Einlesen eines Portinhaltes in ein Register}
function portin (proreg: string; portstr: string): boolean;
var

    schalterindex,
    zustand,
    pinindex: integer;
    portindex,
    regindex,
    fehler : longint;
    ok,
    conected: boolean;
    inhaltstr,
    dummystr,
    zustandstr : string;

begin
  ok := false;
  getregisterinhalt (proreg, regindex, inhaltstr, ok);
  if ok = false then
  begin
    showmessage ('Ungltiges Register');
  end
  else
  begin
    inhaltstr := '';

        if (copy (portstr, 1, 1)) = 'X' then
                    begin
                    hextodec (copy (portstr,2,8), portindex, ok);
                    if ok = false then fehler := 1 else fehler := 0;
                    end
                    else
                    begin
                    val (portstr, portindex, fehler);
                    end;

    if (fehler <> 0) or (portindex < 1) or (portindex > portanzahl) then
    begin
      showmessage ('Ungltige Portangabe');
    end
    else
     if portindex =  18 then
          begin        // Tastatureingabe
            ok := putregister (regindex, keyboardstring);
            ioport[portindex].richtung := eingang;
            keyboardstring := '00000000';
            portin := ok;
            exit;
     end

      else
     begin
      for pinindex:= 1 to portbreite do
      begin
        zustandstr:= '';
        for schalterindex := 1 to schalteranzahl do
        begin
          getconnectarray (schalterindex, portindex, pinindex, conected, zustand, ok);
          if (conected) and (zustand = 1) then
          begin
            zustandstr := '1';
          end;
        end;{ende schalterindex}
        if zustandstr = '' then
        begin
          zustandstr:= '0';
        end;
        inhaltstr := inhaltstr + zustandstr;
        end;  {ende pinindex}

      dummystr:= '00000000000000000000000000000000';
      inhaltstr := copy (dummystr, 1, (32- portbreite )) + inhaltstr;
     { showmessage ('hallo inhaltstr fr Register ' + inttostr (regindex)
                   + ': ' + inhaltstr);}

      ioport[portindex].inhalt := copy (inhaltstr, 25,8);
      inhaltstr := bintohex (inhaltstr);
      ok := putregister (regindex, inhaltstr);
      ioport[portindex].richtung := eingang;
    end;
  end;
  portin := ok;
end;



{pragma}

function pragmabef (ops: string): boolean ;
var
index: integer;
begin
 if ops = 'IO'
  then
  begin
    pragmabef :=pragmaio;
   main.iopragma:= true;
   exit;
   end;

   if ops = 'IOOFF'
   then
   begin
   pragmabef := true;
   main.iopragma := false;
   exit;
   end;

   if ops = 'MEMINIT'
   then
   begin
   main.meminitpragma := true;
   pragmabef := true;
   exit;
   end;

   if ops = 'MEMINITOFF'
   then
   begin
   main.meminitpragma:= false;
   pragmabef := true;
   exit;
   end;

   if ops = 'ALPHA'
   then
   begin
   main.memalpha:= 1;
   pragmabef := true;
   exit;
   end;

   if ops = 'HEX'
   then
   begin
   main.memalpha:= 0;
   pragmabef := true;
   exit;
   end;

   if ops = 'BIN'
   then
   begin
   main.memalpha:= 2;
   pragmabef := true;
   exit;
   end;

   if ops = 'WORD' then
  begin
   if main.membyteadrs = true then
  begin
  //endadresse := endadresse div 4;
  end;

  main.membyteadrs:= false;
  pragmabef := true;
  exit;
  end;

  if ops = 'BYTE' then
  begin
  if main.membyteadrs = false then
  begin
   //endadresse := endadresse * 4;
   end;

  main.membyteadrs:= true;
  pragmabef := true;
  exit;
  end;

  if ops = '4' then
  begin
  main.gera:= 4;
  main.endadresse := 15 ;
  pragmabef := true;
  spform (1);
  exit;
  end;

 if ops ='16' then
 begin
  main.gera:= 16 ;
  main.endadresse:= 255;
  pragmabef := true;
  spform (1);
  exit;
  end;

  
 pragmabef:= false;
 end;



{checkpoint}
 function checkpoint (kost: string): boolean;
 var
 ok:boolean;
  begin
  Main.Checkwin.text:=  kost;
  if pos ('BEEP',kost) <>0
  then
  begin
 ok:= MessageBeep ($ffffffff);
  end;
  checkpoint:= true;
   end;


{Breakpoint}

 function breakpt: boolean;
 begin
       main.runtimer.enabled := false;
       main.plusbtn.enabled := false;
       breakpt := true;
     if MessageDlg('Breakpoint in Zeile ' + inttostr (indexg) + '.  Fortsetzen (Yes) oder Schrittbetrieb (No)?', mtConfirmation,
       [mbYes, mbNo], 0) = mrYes then
       begin
       //plusbtnclick (sender) ;
       main.runtimer.enabled := true;
       end
    else
    begin
      main.breakpp:= true;
      main.runmodus := 2;
      main.stepbtn.enabled := false;
      main.plusbtn.enabled := true;
      main.runbtn.enabled := true;
      //exit;
      end;

 end;

 //******

 {Halt}
 function halt (kost: string): boolean;
 var
 ok:boolean;
  begin
   Main.Checkwin.text:=  kost;
   ok:= MessageBeep ($ffffffff);
   main.haltpp := true;
   halt:= true;
  end;



{******************************************************************************}
{Hier wird der Code sortiert}
function ausfuehren (index : integer) : boolean;
var  aoperator : string;
     operatorgueltig: boolean;
begin
{  showmessage ('hier beginnt das sortieren der befehle von ' + programmstr[indexg]);}
  operatorgueltig := false;
  aoperator := operator[index];
  main.haltpp:= false;
  if aoperator = 'LDI'   then

    operatorgueltig := ldi (operand1[index], operand2[index])

 else if aoperator = 'LD'   then
      operatorgueltig := ld (operand1[index], operand2[index])

 else if aoperator = 'LDB'   then
      operatorgueltig := ldb (operand1[index], operand2[index])

 else if aoperator = 'LDH'   then
      operatorgueltig := ldh (operand1[index], operand2[index])

 else if aoperator = 'LDR'   then

    operatorgueltig := ldR (operand1[index], operand2[index])

 else if aoperator = 'MOV'   then

    operatorgueltig := MOV (operand1[index], operand2[index])

  else if aoperator = 'ST'  then

     operatorgueltig := ST (operand1[index], operand2[index])

 else if aoperator = 'STR'  then

     operatorgueltig := STRBEF(operand1[index], operand2[index])
 else  if aoperator = 'LDSR'  then

    operatorgueltig := LDSR (operand1[index], operand2[index])
  else if aoperator = 'STSR'  then

    operatorgueltig := STSR (operand1[index], operand2[index])

  else if aoperator = 'INC'   then

    operatorgueltig := INC (operand1[index], operand2[index])
  else if aoperator = 'DEC'   then

    operatorgueltig := DEC (operand1[index], operand2[index])
  else  if aoperator = 'ADD'   then

    operatorgueltig := ADD (operand1[index], operand2[index])
  else if aoperator = 'ADDC'  then

    operatorgueltig := ADDC (operand1[index], operand2[index])
 else if aoperator = 'CPL'   then

    operatorgueltig := CPL (operand1[index])
  else if aoperator = 'INV'   then

    operatorgueltig := INV (operand1[index])
  else if aoperator = 'SUB'   then

    operatorgueltig := SUB (operand1[index], operand2[index])
  else if aoperator = 'SUBC'  then

    operatorgueltig := SUBC (operand1[index], operand2[index])
  else if aoperator = 'AND'   then

    operatorgueltig := ANDLOG (operand1[index], operand2[index])

  else if aoperator = 'OR'    then

    operatorgueltig :=ORlog (operand1[index], operand2[index])

  else if aoperator = 'XOR'   then

    operatorgueltig := XORLOG (operand1[index], operand2[index])
  else if aoperator = 'SHL'   then

    operatorgueltig := SHIFTLEFT (operand1[index], operand2[index])

  else if aoperator = 'SHR'   then

    operatorgueltig := SHIFTRIGHT (operand1[index], operand2[index])


  else if aoperator = 'SRA'   then

    operatorgueltig := SHIFTRIGHTA (operand1[index], operand2[index])

  else if aoperator = 'SRAR'   then

    operatorgueltig := SRAR (operand1[index], operand2[index])




  else if aoperator = 'SHRR'  then

    operatorgueltig := SHRR (operand1[index], operand2[index])

  else if aoperator = 'SHLR'  then

    operatorgueltig := SHLR (operand1[index], operand2[index])
  else if aoperator = 'ROTR'  then

    operatorgueltig := ROTR (operand1[index], operand2[index])
  else if aoperator = 'ROTL'  then

    operatorgueltig := ROTL (operand1[index], operand2[index])
  else if aoperator = 'ROTRR' then
    operatorgueltig := ROTRR (operand1[index], operand2[index])
 else if aoperator = 'ROTLR' then

    operatorgueltig := ROTLR (operand1[index], operand2[index])

    else if aoperator = 'RTLX'   then
     operatorgueltig := RTLX (Operand1 [index])

   else if aoperator = 'RTRX'   then
     operatorgueltig := RTRX (Operand1 [index])

    else  if aoperator = 'CMP'   then

    operatorgueltig := CMP (operand1[index], operand2[index])
 else if aoperator = 'PUSH'  then

    operatorgueltig := PUSH (operand1[index])
 else if aoperator = 'PUSHSTA'  then

    operatorgueltig := PUSHSTA (operand1[index])
 else if aoperator = 'PUSHA'  then

    operatorgueltig := PUSHALL ('I')
  else if aoperator = 'POP'  then

    operatorgueltig := POP (operand1[index])
 else if aoperator = 'POPSTA'  then

    operatorgueltig := POPSTA (operand1[index])
 else  if aoperator = 'POPA'  then

    operatorgueltig := POPALL ('A')
  else if aoperator = 'CALL'  then

    operatorgueltig := CALL (operand1[index])
  else if aoperator = 'JMP'   then

    operatorgueltig := JMP (operand1[index])
  else if aoperator = 'RET'   then

    operatorgueltig := RET (operand1[index])
  else if aoperator = 'BRA'   then

    operatorgueltig := BRA (operand1[index])
  else if (aoperator = 'JPE') or (aoperator = 'JPZ')  then

    operatorgueltig := JPZ (operand1[index])
 else if (aoperator = 'JPNE') or (aoperator = 'JPNZ')  then

    operatorgueltig := JPNZ (operand1[index])

  else if (aoperator = 'JPC')  then

    operatorgueltig := JPC (operand1[index])

    else if (aoperator = 'JPBC') then
         operatorgueltig := JPBC (operand1[index])

 else if (aoperator = 'JPNBC') then
         operatorgueltig := JPNBC (operand1[index])

 else if (aoperator = 'JPD') then
         operatorgueltig := JPD (operand1[index])

 else if (aoperator = 'JPND') then
         operatorgueltig := JPND (operand1[index])


 else if (aoperator = 'JPNC')  then

    operatorgueltig := JPNC (operand1[index])
  else if (aoperator = 'JPP')  then

    operatorgueltig := JPP (operand1[index])
  else if (aoperator = 'JPN')  then

    operatorgueltig := JPN (operand1[index])
  else if (aoperator = 'JPB')  then

    operatorgueltig := JPB (operand1[index])

 else if (aoperator = 'JPA')  then

    operatorgueltig := JPA (operand1[index])
  else if (aoperator = 'JPBE')  then

    operatorgueltig := JPBE (operand1[index])
  else if (aoperator = 'JPAE')  then

    operatorgueltig := JPAE (operand1[index])
  else if (aoperator = 'JPL')  then

    operatorgueltig := JPL (operand1[index])
  else if (aoperator = 'JPG')  then

    operatorgueltig := JPG (operand1[index])
 else if (aoperator = 'JPNL') or (aoperator = 'JPGE')  then

    operatorgueltig := JPNL (operand1[index])
  else if (aoperator = 'JPNG') or (aoperator = 'JPLE')  then

    operatorgueltig := JPNG (operand1[index])
  else if (aoperator = 'SET') then

    operatorgueltig := SETB (operand1[index], operand2[index])
  else if (aoperator = 'CLR') then

    operatorgueltig := CLR (operand1[index], operand2[index])
  else if (aoperator = 'CLRR') then

    operatorgueltig := CLRR (operand1[index], operand2[index])

  else if (aoperator = 'SETR') then

    operatorgueltig := SETR (operand1[index], operand2[index])

  else if (aoperator = 'BIT') then

    operatorgueltig := BIT (operand1[index], operand2[index])
 else if (aoperator = 'BITR') then

    operatorgueltig := BITR (operand1[index], operand2[index])

 else if (aoperator = 'BZF') then

    operatorgueltig := BZF (operand1[index], operand2[index])

  else if (aoperator = 'BZFR') then

    operatorgueltig := BZFR (operand1[index], operand2[index])


 else if (aoperator = 'OUT') then

    operatorgueltig := OUT (operand1[index], operand2[index])


  else if (aoperator = 'IN') then

    operatorgueltig := portin (operand1[index], operand2[index])

  else if (aoperator = 'NOP') then
     operatorgueltig := true

 else if ( copy (aoperator,1,1) = ';') then
      operatorgueltig := true

 else if ( copy (aoperator,1,2)  = '--') then
     operatorgueltig := true

      else if (aoperator = 'PRAGMA') then
     operatorgueltig := pragmabef (operand1[index])

     else if (aoperator = 'HALT') then
     operatorgueltig := halt (operand1[index])

 else if (aoperator = 'CHECKPOINT') or (aoperator = 'CHK') then
 operatorgueltig := checkpoint (checkstri[indexg])

 else if (aoperator = 'BREAKPOINT') or (aoperator = 'BRK') then
 operatorgueltig := breakpt ();

// letzte Aktion - alles abgefragt, also ungltiger Operator oder Fehler bei Ausfhrung

   if  operatorgueltig <> true then
   begin
   showmessage ('Ungltige Operation');
   main.runtimer.enabled := false;
   ausfuehren:= false;
   end
   else
   begin
    ausfuehren := true;
  end;
end;

{******************************************************************************}
{Hier wird der Kommentar bestimmt}
function kommentieren (index : integer) : boolean;
var  aoperator,
     kommstr : string;
     n,
     wert,
     fehler: integer;
     begin
 if main.iopragma = true  then
    begin
    kommstr := ' ';
    for n := 3 to 9 do
    begin
    kommstr := kommstr + 'Port ' + inttohex (n,1)+ ': '+ (ioport[n].inhalt) + '   ' ;
    end;


    kommentar (kommstr);
    end
 else

  aoperator := operator[index];
  if aoperator = 'LDI'   then
  begin
    kommentar ('Laden von Direktwert ');
  end;
  if aoperator = 'LD'   then
  begin
    kommentar ('Laden des Inhaltes einer Speicherzelle in ein Prozessorregister');
  end;
    if aoperator = 'LDB'   then
  begin
    kommentar ('Laden eines Bytes aus dem Speicher in ein Prozessorregister');
  end;
   if aoperator = 'LDH'   then
  begin
    kommentar ('Laden eines Halbworts aus dem Speicher in ein Prozessorregister');
  end;
  if aoperator = 'LDR'   then
  begin
    kommentar ('Schreiben des Inhaltes gem Speicheradresse n Quellregister ins Zielregister ');
  end;
  if aoperator = 'MOV'   then
  begin
    kommentar ('Ldt den Inhalt eines Registers in ein anderes Register');
  end;
  if aoperator = 'ST'  then
  begin
    kommentar('Speichern des Inhaltes ein Prozessorregisters in einer Speicherzelle');
  end;
  if aoperator = 'STR'  then
  begin
    kommentar ('Speichern des Inhaltes der Adresse von Quellregister, in der Adresse von Zielregister');
  end;
  if aoperator = 'LDSR'  then
  begin
    kommentar ('Laden des Inhaltes eines Sonderregisters in ein Prozessorregister');
  end;
  if aoperator = 'STSR'  then
  begin
    kommentar ('Laden des Inhaltes eines Prozessorregister in ein Sonderregister');
  end;
  if aoperator = 'INC'   then
  begin
    kommentar ('Erhhen des Registerinhaltes um einen Direktwert');
  end;
  if aoperator = 'DEC'   then
  begin
    kommentar ('Verringern des Registerinhaltes um einen Direktwert');
  end;
    if aoperator = 'ADD'   then
  begin
    kommentar ('Addieren zweier Prozessorregisterinhalte ohne bertrag');
  end;
  if aoperator = 'ADDC'  then
  begin
    kommentar ('Addieren zweier Prozessorregisterinhalte mit bertrag');
  end;
  if aoperator = 'CPL'   then
  begin
    kommentar ('Bilden des Zweierkomplements ');
  end;
  if aoperator = 'INV'   then
  begin
    kommentar ('Invertieren des Registerinhalts ');
  end;
  if aoperator = 'SUBC'   then
  begin
    kommentar ('Subtrahieren zweier Prozessorregisterinhalte mit bertrag');
  end;
  if aoperator = 'SUB'  then
  begin
    kommentar ('Subtrahieren zweier Prozessorregisterinhalte');
  end;
  if aoperator = 'AND'   then
  begin
    kommentar ('Bitweise "Und"-Vernpfung zweier Prozessorregisterinhalte');
  end;
  if aoperator = 'OR'    then
  begin
    kommentar ('Bitweise "Oder"-Vernpfung zweier Prozessorregisterinhalte');
  end;
  if aoperator = 'XOR'   then
  begin
    kommentar ('Bitweise "Antivalenz"-Vernpfung zweier Prozessorregisterinhalte');
  end;
  if aoperator = 'SHL'   then
  begin
    kommentar ('Linksschieben eines Registerinhaltes um n-Stellen');
  end;

  if aoperator = 'SRA'   then
  begin
    kommentar ('Rechtsschieben eines Registerinhaltes a um n Stellen mit Weiterschieben der Vorzeichenstelle');
  end;

 if aoperator = 'SRAR'   then
  begin
    kommentar ('Rechtsschieben eines Registerinhaltes a gem Registerinhalt b mit Weiterschieben der Vorzeichenstelle');
  end;

  if aoperator = 'SHRR'  then
  begin
    kommentar ('Rechtsschieben eines Registerinhaltes a gem Registerinhalt b');
  end;
  if aoperator = 'SHLR'  then
  begin
    kommentar ('Linksschieben eines Registerinhaltes a gem Registerinhalt b');
  end;
  if aoperator = 'ROTR'  then
  begin
    kommentar ('Bitweises "Rechts-rotieren" eines Registerinhaltes"a" um n-Stellen');
  end;
  if aoperator = 'ROTL'  then
  begin
    kommentar ('Bitweises "Links-rotieren" eines Registerinhaltes"a" um n-Stellen');
  end;
  if aoperator = 'ROTRR' then
  begin
    kommentar ('Bitweises "Rechts-rotieren" eines Registerinhaltes"a" um Inhalt "b"');
  end;
  if aoperator = 'ROTLR' then
  begin
    kommentar ('Bitweises "Links-rotierenen" eines Registerinhaltes"a" um Inhalt "b"');
  end;
   if aoperator = 'CMP'   then
  begin
    kommentar ('Vergleichen zweier Prozessorregisterinhalte');
  end;
  if aoperator = 'PUSH'  then
  begin
    kommentar ('Schieben eines Registerinhaltes auf den Stack');
  end;
  if aoperator = 'PUSHSTA'  then
  begin
    kommentar ('Schieben des Statusregisterinhaltes auf den Stack');
  end;
  if aoperator = 'PUSHA'  then
  begin
    kommstr :='Schieben des Statusregisterinhaltes und aller ';
    kommstr := kommstr + ' Prozessorregisterinhalte auf den Stack';
    kommentar (kommstr);
  end;
  if aoperator = 'POP'  then
  begin
    kommentar ('Laden eines Registerinhaltes vom Stack');
  end;
  if aoperator = 'POPSTA'  then
  begin
    kommentar ('Lesen des Statusregisterinhaltes vom Stack');
  end;
   if aoperator = 'POPA'  then
  begin
    kommentar ('Lesen des Statusregisterinhaltes und aller Prozessorregisterinhalte vom Stack');
  end;
  if aoperator = 'CALL'  then
  begin
    kommentar ('Aufrufen eines Unterprogrammes');
  end;
  if aoperator = 'JMP'   then
  begin
    kommentar ('Springen zu Marke');
  end;
  if aoperator = 'RET'   then
  begin
    kommentar ('Laden des Programmzhler vom Stack');
  end;
  if aoperator = 'BRA'   then
  begin
    kommentar ('Springen auf Programmzeile aus Register');
  end;

   if (aoperator = 'JPBC')  then
  begin
    kommentar ('Springen zur Marke bei BCD-Carryflag ');
  end;

     if (aoperator = 'JPNBC')  then
  begin
    kommentar ('Springen zur Marke bei "BCD-Carryflag = false" ');
  end;

  if (aoperator = 'JPD')  then
  begin
    kommentar ('Springen zur Marke bei Dummy-Flag');
  end;

  if (aoperator = 'JPNF')  then
  begin
    kommentar ('Springen zur Marke bei "Dummy-Flag = false" ');
  end;

  if (aoperator = 'JPE') or (aoperator = 'JPZ')  then
  begin
    kommentar ('Springen zur Marke bei Zeroflag (Gleichheit oder "0")');
  end;
  if (aoperator = 'JPNE') or (aoperator = 'JPNZ')  then
  begin
    kommentar ('Springen zur Marke bei "Zeroflag = false" Ungleichheit oder "0")');
  end;
  if (aoperator = 'JPC')  then
  begin
    kommentar ('Springen zur Marke bei Carryflag ');
  end;
  if (aoperator = 'JPNC')  then
  begin
    kommentar ('Springen zur Marke bei "Carryflag = false" Ungleichheit oder "0")');
  end;
  if (aoperator = 'JPO')  then
  begin
    kommentar ('Springen zur Marke bei Overflowflag ');
  end;
  if (aoperator = 'JPNO')  then
  begin
    kommentar ('Springen zur Marke bei "Overflowflag = false" Ungleichheit oder "0")');
  end;
  if (aoperator = 'JPP')  then
  begin
    kommentar ('Springen zur Marke bei Signedflag = false ');
  end;
  if (aoperator = 'JPN')  then
  begin
    kommentar ('Springen zur Marke bei "Signedflag = true" Ungleichheit oder "0")');
  end;
  if (aoperator = 'JPB')  then
  begin
    kommentar ('Springen wenn A<B');
  end;
  if (aoperator = 'JPA')  then
  begin
    kommentar ('Springen wenn A>B');
  end;
  if (aoperator = 'JPBE')  then
  begin
    kommentar ('Springen wenn A<=B');
  end;
  if (aoperator = 'JPAE')  then
  begin
    kommentar ('Springen wenn A>=B');
  end;
  if (aoperator = 'JPL')  then
  begin
    kommentar ('Springen wenn A<B');
  end;
  if (aoperator = 'JPG')  then
  begin
    kommentar ('Springen wenn A>B');
  end;
  if (aoperator = 'JPNL') or (aoperator = 'JPGE')  then
  begin
    kommentar ('Springen wenn A>=B');
  end;
  if (aoperator = 'JPNG') or (aoperator = 'JPLE')  then
  begin
    kommentar ('Springen wenn A<=B');
  end;
  if (aoperator = 'SETB') then
  begin
    kommentar ('Bit in Register setzen zu "1"');
  end;
  if (aoperator = 'CLR') then
  begin
    kommentar ('Bit in Register lschen  zu "0"');
  end;
  if (aoperator = 'CLRR') then
  begin
    kommentar ('Bit nach Angabe von Register "b", in Register "a" lschen  zu "0"');
  end;
  if (aoperator = 'SETR') then
  begin
    kommentar ('Bit nach Angabe von Register "b", in Register "a" lschen  zu "0"');
  end;
  if (aoperator = 'BIT') then
  begin
    kommentar ('Test Bit in Register prfen und ZF setzen ');
  end;
  if (aoperator = 'BITR') then
  begin
    kommentar ('Test Bit, nach Register "b", in Register" " prfen und ZF setzen ');
  end;
    if (aoperator = 'BZF') then
  begin
    kommentar ('Kopiere ZF invertiert in das Bit im Register');
  end;
  if (aoperator = 'BZFR') then
  begin
    kommentar ('Kopiere ZF invertiert nach Angabe von Register "b" in Bit des Registers "a"');
  end;

  if aoperator = 'RTLX' then
  begin
    kommentar ('Rotiere unm 1 Bit nach links ber CF (CF => Bit 0)');
   end;

   if aoperator = 'RTRX' then
  begin
    kommentar ('Rotiere unm 1 Bit nach rechts ber CF (CF => Bit 31)');
   end;

  if aoperator = 'PRAGMA' then
  begin
    kommentar ('Steuerung der Ablaufumgebung');
   end;

  if (aoperator = 'OUT') then
  begin
    kommentar ('Ausgabe des Registerinhaltes auf die Ports');
  end;
  if (aoperator = 'IN') then
  begin
    kommentar ('Einlesen von Port in Register');
  end;

  if (aoperator = 'NOP') then
  begin
     kommentar ('Keine Operation');
  end;

 if (copy (aoperator, 1,2) = '--') then
  begin
     kommentar ('Platzhalter - zur Zeit keine Operation');
  end;

  if (aoperator = 'CHECKPOINT') or (aoperator = 'CHK') then
  begin
      kommentar ('Checkpoint anzeigen');
  end;

  if (aoperator = 'BREAKPOINT') or (aoperator = 'BRK') then
  begin
      kommentar ('Breakpoint erreicht');
      end;



if (copy (aoperator,1,1) = ';') then

  begin
     kommentar ('Kommentarzeile - keine Operation');
  end;

  kommentieren := true;
end;







end.
