unit schalterunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Grids, StdCtrls, infobox;

type
  Tschalterpanel = class(TForm)
    MainMenu1: TMainMenu;
    Verknuepfungen: TMenuItem;
    Schliessen1: TMenuItem;
    Hilfe: TMenuItem;
    Hilfetext: TMenuItem;
    Info1: TMenuItem;
    schalterGrid: TStringGrid;
    protlabel: TLabel;
    PinLabel: TLabel;
    Label2: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure ButtonClick(Sender: TObject);
    procedure MenuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Info1Click(Sender: TObject);
    procedure Schliessen1Click(Sender: TObject);
    procedure schalterGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure HilfetextClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  schalterpanel: Tschalterpanel;


procedure fillschaltergrid (ischalter : integer);
 function putschalter (nummer: integer) : boolean;

implementation
uses pfsimunit, IOPORTUNIT;
{$R *.DFM}


function putschalter (nummer: integer) : boolean;
var value,
    portindex,
    pinindex : integer;

    conected,
    richtig : boolean;
begin
  portindex := 1;
  pinindex := 1;
  getconnectarray (nummer, portindex, pinindex, conected, value, richtig);
  if (nummer < 1) or (nummer > schalteranzahl) or (richtig = false) then
  begin
    showmessage ('Unzulssige Schalternummer');
  end
  else
  begin
    schalter [nummer]. caption := inttostr (nummer);
{   showmessage ('schalter wurde zu ' + inttostr (value));}
    if ( value = 1) then
    begin
      schalter [nummer].glyph.loadfromfile ('kippschalter-1.bmp');
    end
    else
    begin
      if ( value = 0)then
      begin
        schalter [nummer].glyph.loadfromfile ('kippschalter-0.bmp');
     end
    end;
  end;
  putschalter := richtig;
end;



procedure Tschalterpanel.FormCreate(Sender: TObject);
var index,
    value : integer;
    richtig,
    conected : boolean;
    menueintrag : tmenuitem;
begin
  schalterpanel.width := ((schalteranzahl -1) div 8 )* 100 + 120 ;
  for index := 1 to schalteranzahl do
  begin
    schalter [index]:= tswitch.create (main);
    schalter [index].parent := self;
    schalter [index].height := 30;
    schalter [index]. top := (index -1)mod 8  * 35 + 10 ;
    schalter [index]. width := 85;
    schalter [index].left := ((index -1) div 8 )* 100 + 10;
    schalter [index].layout:= blglyphleft;
    schalter [index].visible :=  true;
{    schalter [index].helpcontext := 2210;}
    schalter [index].OnClick := ButtonClick;

    getconnectarray (index, 1, 1, conected, value, richtig);

    putconnectarray (index, 1, 1, false, value);
    putschalter (index);

                                             {Erzeugen von Menueintrgen }
    menueintrag := tmenuitem.create (self);
    menueintrag.caption := 'Schalter' + inttostr (index);
    menueintrag.tag := index;
    verknuepfungen.add (menueintrag);
    menueintrag. onclick := menuclick;

  end;
                                              {Erzeugen der ConnectTabelle}
  schaltergrid.width:= schalterpanel.width - 45;
  schaltergrid.height := (schaltergrid.rowcount + 3)* 15;
  schaltergrid.colcount:= portanzahl + 1 ;
  schaltergrid.rowcount:= portbreite + 1 ;

  for index := 1 to portanzahl do
  schaltergrid.cells[index, 0] := inttostr (index);

  for index := 1 to portbreite do
  schaltergrid.cells[0, index] := inttostr (index);

end;



procedure fillschaltergrid (ischalter : integer);
var iport,
    ipin,
    value : integer;
    iconnected,
    ok : boolean;
    inhaltstr : string;
begin
  schalterpanel.label2.caption := 'Schalter '+ inttostr (ischalter) + ' : ';
  for iport := 1 to portanzahl do
    for ipin := 1 to portbreite do
    begin
      getconnectarray (ischalter, iport, ipin, iconnected, value, ok);
      if ok = false then
      begin
        showmessage ('Ungltige Connectarrayabfrage');
      end
      else
      begin
        if iconnected = true then
        begin
          inhaltstr := '1';
        end
        else
        begin
          inhaltstr := '0';
      end;
{      inhaltstr := inhaltstr + inttostr (value);}
      schalterpanel.schaltergrid.cells[iport, ipin] := inhaltstr;
    end;
  end;
end;


procedure Tschalterpanel.ButtonClick(Sender: TObject);
var
  Button: TSwitch;
  conected,
  richtig : boolean;
  schalterindex,
  portindex,
  pinindex,
  egal,
  value: integer;
begin
  if Sender is TSwitch then
   begin
     Button := Sender as TSwitch;
     for schalterindex := 1 to schalteranzahl do
     begin
       if Schalter[schalterindex] = Button then
       begin
         main.runtimer.enabled := false;
         getconnectarray (schalterindex, 1, 1, conected, value, richtig);
       {  ShowMessage ('Schalter '+ inttostr (schalterindex) +' gedrckt');}
         if value = 1 then
         begin
           value := 0;
         end
         else
         begin
           value := 1;
         end;
         for portindex := 1 to portanzahl  do
           for pinindex := 1 to portbreite  do
           begin
             getconnectarray (schalterindex, portindex, pinindex, conected, egal, richtig);
             putconnectarray (schalterindex, portindex, pinindex, conected, value);
           end; {ende pinindex}
           fillschaltergrid (schalterindex);
           putschalter (schalterindex);
           ioportbox.aktualisierenclick (sender);
           if (main.runmodus = 1) or (main.runmodus = 4)then
              main.runtimer.enabled := true;
         {ende portindex}
       end;
     end; {ende schalterindex}
   end;
end;




procedure Tschalterpanel.menuClick(Sender: TObject);
var
  eintrag : tmenuitem;
  ischalter: integer;
begin
  if Sender is Tmenuitem then
  begin
     eintrag := Sender as Tmenuitem;
{     showmessage ('hurra' + eintrag.caption);}
     for ischalter := 1 to schalteranzahl do
     begin
       if  ischalter = eintrag.tag then
       begin
         fillschaltergrid (ischalter);
       end;
     end;
   end;
end;


procedure Tschalterpanel.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  main.schalterbtn.glyph.loadfromfile ('kippschalter-0.bmp');
  schalterbtnzustand := false;
  main.schalterein1.enabled:= true;
  main.schalteraus1.enabled := false;

end;

procedure Tschalterpanel.Info1Click(Sender: TObject);
begin
  aboutbox.show;
end;

procedure Tschalterpanel.Schliessen1Click(Sender: TObject);
begin
  main.schalterbtn.glyph.loadfromfile ('kippschalter-0.bmp');
  schalterbtnzustand := false;
  main.schalterein1.enabled:= true;
  main.schalteraus1.enabled := false;
  close;
end;

procedure Tschalterpanel.schalterGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
var inhaltstr,
    schalterstr : string;
    ok,
    schalterconnected : boolean;
    value,
    schalterindex,
    fehler : integer;

begin
  schalterstr :=   schalterpanel.label2.caption;
  schalterstr := copy (schalterstr, 10, length(schalterstr) - 11);
  val (schalterstr, schalterindex, fehler);
  getconnectarray (schalterindex, col, row, schalterconnected, value, ok);
  if schalterconnected = true then
  begin
{    showmessage ('schalterconected = true');}
    inhaltstr := '1';
  end
  else
  begin
    inhaltstr := '0';
  end;
  begin
    if inhaltstr = '1' then
    begin
      putconnectarray (schalterindex, col, row, false, value);
      inhaltstr := '0';
    end
    else
    begin
      if inhaltstr = '0' then
      begin
        putconnectarray(schalterindex, col, row, true, value);
        inhaltstr := '1';
      end;
    end;
   { inhaltstr := inhaltstr + inttostr (value);}
    schaltergrid.cells[col, row] := inhaltstr;
    ioportbox.aktualisierenclick (sender);
  end;
end;



procedure Tschalterpanel.HilfetextClick(Sender: TObject);
begin
  application.helpfile :=diplomhilfedatei;
  application.helpjump ('');
end;


end.
