unit speicherbox;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, Grids;

type
  TSpeicheransicht = class(TForm)
    Label3: TLabel;
    Label4: TLabel;
    MainMenu1: TMainMenu;
    Hilfe1: TMenuItem;
    Hilfetext1: TMenuItem;
    Info1: TMenuItem;
    Schliessen1: TMenuItem;
    Timer1: TTimer;
    ListBox1: TListBox;
    Ansicht1: TMenuItem;
    Liste1: TMenuItem;
    Tabelle1: TMenuItem;
    RadioGroup1: TRadioGroup;
    Listenansicht: TRadioButton;
    Tabellenansicht: TRadioButton;
    Speichergrid: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Schliessen1Click(Sender: TObject);
    procedure aktualisieren1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListenansichtClick(Sender: TObject);
    procedure TabellenansichtClick(Sender: TObject);
    procedure Hilfetext1Click(Sender: TObject);

  private
{ Private-Deklarationen }
  public
  { Public-Deklarationen }

  end;

var
  Speicheransicht: TSpeicheransicht;
  binbox : tedit;

function hextobin (hexstr : string) : string;
function bintohex (binstr : string) : string;
procedure hextodec(hexstr: string; VAR decwert: longint; Var OK : boolean) ;
  procedure spform (ad: integer);

implementation
uses pfsimunit, Infobox, display;
{$R *.DFM}

{Wandelt einen Hexstring in einen Binrstring um. }
function hextobin (hexstr : string) : string;
var binstr,
    teilstr : string;
    index : integer;
begin
  binstr :=''   ;
  for index := 1 to length (hexstr) do
  begin
    case  hexstr[index] of
      '0' :  teilstr := '0000';
      '1' :  teilstr := '0001';
      '2' :  teilstr := '0010';
      '3' :  teilstr := '0011';
      '4' :  teilstr := '0100';
      '5' :  teilstr := '0101';
      '6' :  teilstr := '0110';
      '7' :  teilstr := '0111';
      '8' :  teilstr := '1000';
      '9' :  teilstr := '1001';
      'A','a' :  teilstr := '1010';
      'B','b' :  teilstr := '1011';
      'C','c' :  teilstr := '1100';
      'D','d' :  teilstr := '1101';
      'E','e' :  teilstr := '1110';
      'F','f' :  teilstr := '1111';
    end;
    binstr := binstr + teilstr;
  end;
  hextobin := binstr;
{  showmessage (binstr);}
end;

{Wandelt eine Hexzahl in eine Dezimalzahl um, incl. Bereichsprfung.}
procedure hextodec(hexstr: string; VAR decwert: longint; Var OK : boolean) ;
var wert,
    nummer,
    fehler,
    index,
    hex1 : longint;
begin
  index:= 1;
  nummer := 0;
  ok := false;
  wert := 0;
  decwert := 0;
  if length (hexstr) = 8 then
  begin
    val (hexstr[1] , wert, fehler);
    if ((fehler = 0) and (wert > 7 )) then
    begin
      nummer := 1;
    end;
    hexstr[1] := upcase (hexstr[1]);
    if ( (hexstr[1] = 'A') or (hexstr[1] = 'B') or (hexstr[1] = 'C')
       or (hexstr[1] = 'D') or (hexstr[1] = 'E') or  (hexstr[1] = 'F' ))then
    begin
      nummer := 1;
    end   ;
  end;
  index:= index + nummer;
  repeat
    hexstr[index] := upcase (hexstr[index]);
    if ((ord (hexstr[index]) >= 48) and (ord (hexstr[index]) < 58)  or
        (ord (hexstr[index])  >= 65) and (ord (hexstr[index]) < 71)) then
    begin
      decwert := decwert * 16;
      case hexstr[index] of
        '0'  : wert:= 0;
        '1'  : wert:= 1;
        '2'  : wert:= 2;
        '3'  : wert:= 3;
        '4'  : wert:= 4;
        '5'  : wert:= 5;
        '6'  : wert:= 6;
        '7'  : wert:= 7;
        '8'  : wert:= 8;
        '9'  : wert:= 9;
        'A'  : wert:= 10;
        'B'  : wert:= 11;
        'C'  : wert:= 12;
        'D'  : wert:= 13;
        'E'  : wert:= 14;
        'F'  : wert:= 15;
      end; {end case}
      decwert := decwert + wert;
      index := index + 1;
      ok := true;
    end
    else
    begin
      ok:=false;
    end;
  until ((ok = false) or (index=9) or (hexstr[index] = ''));


  if nummer = 1 then
  begin
    decwert := decwert- 2147483647 - 1;
    hextodec (hexstr[1], hex1, ok);
    decwert := decwert + (hex1-8)* 268435456;  {2^28}
    ok:= true;
  end;
end;

{Wandelt einen Binrstring in einen Hexstring um.
 Zerlegt den String in 4 Zeichen lange Stcke und wandelt diese in
 Hexzeichen um. }
function bintohex (binstr : string) : string;
var hexstr : string[8];
    teilstr : string;
    index : integer;
begin
  hexstr :=''   ;
  for index := 1 to 8 do
  begin
    teilstr := copy  (binstr, 1+(index-1)* 4, 4);
    if teilstr = '0000' then hexstr[index] := '0';
    if teilstr = '0001' then hexstr[index] := '1';
    if teilstr = '0010' then hexstr[index] := '2';
    if teilstr = '0011' then hexstr[index] := '3';
    if teilstr = '0100' then hexstr[index] := '4';
    if teilstr = '0101' then hexstr[index] := '5';
    if teilstr = '0110' then hexstr[index] := '6';
    if teilstr = '0111' then hexstr[index] := '7';
    if teilstr = '1000' then hexstr[index] := '8';
    if teilstr = '1001' then hexstr[index] := '9';
    if teilstr = '1010' then hexstr[index] := 'A';
    if teilstr = '1011' then hexstr[index] := 'B';
    if teilstr = '1100' then hexstr[index] := 'C';
    if teilstr = '1101' then hexstr[index] := 'D';
    if teilstr = '1110' then hexstr[index] := 'E';
    if teilstr = '1111' then hexstr[index] := 'F';
  end;

  for index := 1 to 8 do
  begin
    hexstr := hexstr+ hexstr[index];
 {   showmessage (inttostr (index) + '.hexstr: ' + hexstr);}
  end;
  bintohex := hexstr;
end;

{Setzt eine Makierung auf die aktuelle Stackposition im Speicher}
function setstackpointer(ok : boolean) : boolean;
var  stackstr : string;
     stackpointer : longint;
begin
  ok:= false;
  stackstr := getstackstring (ok);
  hextodec (stackstr, stackpointer, ok);
{  showmessage('stackpointer: ' + inttostr (stackpointer));}
  if ok = false then
  begin
    showmessage ('Ungltige Stackadresse');
  end
  else
  begin
    speicheransicht.listbox1.itemindex := endadresse - stackpointer;
  end;
  setstackpointer := ok;
end;

procedure TSpeicheransicht.Info1Click(Sender: TObject);
begin
  aboutbox.show;
end;

procedure TSpeicheransicht.Schliessen1Click(Sender: TObject);
begin
  speicherbtnzustand := false   ;
  main.speicherbtn1.glyph.loadfromfile ('chip16.bmp');
  speicheransicht.close;
end;

procedure TSpeicheransicht.FormCreate(Sender: TObject);
var index : integer;
    ok : boolean;
begin
  ok:= false;
  listbox1.clear;
  for index := endadresse downto 0 do
  begin
    listbox1.items.add (speicher[index]);
  end;
  ok:=setstackpointer( ok);
  for index := 0 to main.gera-1 do
  begin
    speichergrid.cells[index+1, 0] := inttohex ((index), 1);
  end;
  for index := 1 to ((main.endadresse+1) div (main.gera- 1)) do
  begin
    speichergrid.cells[0, index] := inttohex (((index-1) * main.gera),3 );
  end;
end;



    procedure spform (ad: integer);
    var index,
    zeile,
    spalte ,
    n: integer;
    hilf: longint;
    ok : boolean;
    inhaltstr,
    istr : string;
    begin

  speicheransicht.speichergrid.rowcount := (main.endadresse div main.gera)+ 2;
  speicheransicht.speichergrid.colcount := main.gera+1;


 for index := 0 to main.gera-1 do
  begin
   speicheransicht.speichergrid.cells[index+1, 0] := inttohex ((index), 1);
  end;
  for index := 1 to ((main.endadresse+1) div (main.gera- 1)) do
  begin
    speicheransicht.speichergrid.cells[0, index] := inttohex (((index-1) * main.gera),3 );
  end;

  ok:= false;
  speicheransicht.listbox1.clear;
     for index := main.endadresse downto 0  do
  begin
    inhaltstr := (speicher[index]);
    if main.memalpha = 1 then
       begin
       istr :='';
       for n := 0 to 3   do
       begin
       hextodec  (copy (inhaltstr, ((2 * n)+12), 2),hilf, ok);
       if chr (hilf) = '' then istr:= istr + chr (1) +' ' else istr := istr + chr (hilf) + ' ';
       inhaltstr := copy (Inhaltstr, 1, 11) + istr;
       end;
      end;
    speicheransicht.listbox1.items.add (inhaltstr);
    zeile  := ((index) mod main.gera) +1;
    spalte := (((index) div main.gera)) + 1 ;

    inhaltstr :=  speicher [index][18]+ speicher[index][19];
       if main.memalpha = 1 then
       begin
       hextodec (inhaltstr, hilf,ok);
       inhaltstr := chr (hilf);
       end
       else if main.memalpha = 2 then
       begin
        hextodec (inhaltstr, hilf,ok);
        if ok = true then hilf := hilf and 1;
       inhaltstr := inttostr (hilf);
        end;

    speicheransicht.speichergrid .cells [zeile, spalte] := inhaltstr;

  end;
  ok := setstackpointer(ok);
end;


  procedure TSpeicheransicht.aktualisieren1Click(Sender: TObject);
var index,
    zeile,
    spalte,
    n: integer;
    hilf : longint;
    ok : boolean;
    inhaltstr,
    istr : string;
begin
  ok:= false;
  listbox1.clear;
  for index := main.endadresse downto 0  do
  begin
    inhaltstr := (speicher[index]);
    if main.memalpha = 1 then
       begin
       istr :='';
       for n := 0 to 3   do
       begin
       hextodec  (copy (inhaltstr, ((2 * n)+12), 2),hilf, ok);
       if chr (hilf) = '' then istr:= istr + chr (1) +' ' else istr := istr + chr (hilf) + ' ';
       end;
       inhaltstr := copy (inhaltstr, 1, 11) + istr;
     end;

    listbox1.items.add (inhaltstr);
    zeile  := ((index) mod main.gera) +1;
    spalte := (((index) div main.gera)) + 1 ;
 // Matrixdarstellung
    inhaltstr :=  speicher [index][18]+ speicher[index][19];
       if main.memalpha = 1 then
       begin
       hextodec (inhaltstr, hilf,ok);
       inhaltstr := chr (hilf);
       end
       else if main.memalpha = 2 then
       begin
        hextodec (inhaltstr, hilf,ok);
       hilf := hilf and 1;
       if ok = true then inhaltstr := inttostr (hilf);
        end;

    speichergrid .cells [zeile, spalte] := inhaltstr; //haltstr[19];
    
  end;
  ok := setstackpointer(ok);
end;

procedure TSpeicheransicht.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    main.speicherbtn1.glyph.loadfromfile ('chip16.bmp');
    speicherbtnzustand := false;
    main.speicherein1.enabled := true;
    main.speicheraus1.enabled := false;
end;

procedure TSpeicheransicht.ListenansichtClick(Sender: TObject);
begin
  speicheransicht.width  :=  230;
  speicheransicht.height := 490;
  Listbox1.visible := true;
  label3.visible := true;
  label4.visible := true;
  speichergrid. visible := false;
   speicheransicht.aktualisieren1click(sender);
  end;

procedure TSpeicheransicht.TabellenansichtClick(Sender: TObject);

begin

  speicheransicht.width  := 480;
  speicheransicht.height := 300;
  speichergrid.width := speicheransicht.width - 20;
  speichergrid.height := speicheransicht.height - 120;
  Listbox1.visible := false;
  label3.visible := false;
  label4.visible := false;
  speichergrid. visible := true;
  speichergrid.rowcount := (main.endadresse div main.gera)+ 2;
  speichergrid.colcount := main.gera+1;
  speicheransicht.aktualisieren1click(sender);
  end;

procedure TSpeicheransicht.Hilfetext1Click(Sender: TObject);
begin
  application.helpfile :=diplomhilfedatei;
  application.helpjump ('');
end;

end.
